SystemOrganization addCategory: #'Seaside/Base-Core'!
SystemOrganization addCategory: #'Seaside/Base-Handlers'!
SystemOrganization addCategory: #'Seaside/Base-Responses'!
SystemOrganization addCategory: #'Seaside/Base-Document'!
SystemOrganization addCategory: #'Seaside/Base-Utilities'!
SystemOrganization addCategory: #'Seaside/Base-Connections'!
SystemOrganization addCategory: #'Seaside/Base-Platform'!
SystemOrganization addCategory: #'Seaside/Base-Configuration'!
SystemOrganization addCategory: #'Seaside/Base-Configurations'!
SystemOrganization addCategory: #'Seaside/Base-Info'!
SystemOrganization addCategory: #'Seaside/Session-Core'!
SystemOrganization addCategory: #'Seaside/Session-State'!
SystemOrganization addCategory: #'Seaside/Session-Filters'!
SystemOrganization addCategory: #'Seaside/Session-Backtracking'!
SystemOrganization addCategory: #'Seaside/Session-Tests'!
SystemOrganization addCategory: #'Seaside/Session-Utilities'!
SystemOrganization addCategory: #'Seaside/Rendering-Core'!
SystemOrganization addCategory: #'Seaside/Rendering-Callbacks'!
SystemOrganization addCategory: #'Seaside/Component-Core'!
SystemOrganization addCategory: #'Seaside/Component-Tasks'!
SystemOrganization addCategory: #'Seaside/Component-Dialogs'!
SystemOrganization addCategory: #'Seaside/Component-Widgets'!
SystemOrganization addCategory: #'Seaside/Component-Reporting'!
SystemOrganization addCategory: #'Seaside/Component-Configuration'!
SystemOrganization addCategory: #'Seaside/Component-Tools'!
SystemOrganization addCategory: #'Seaside/Component-Tools-Squeak'!
SystemOrganization addCategory: #'Seaside/Component-Utilities'!
SystemOrganization addCategory: #'Seaside/Examples-Test'!
SystemOrganization addCategory: #'Seaside/Examples-Store-Model'!
SystemOrganization addCategory: #'Seaside/Examples-Store'!

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Utilities'!

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID methodsFor: 'private' stamp: 'ab 7/3/2003 14:57'!
initialize
	1 to: self size do: [:i | self at: i put: (($a to: $z), ($A to: $Z)) atRandom asInteger]! !

!WAExternalID methodsFor: 'private' stamp: 'ab 5/29/2003 00:00'!
printOn: stream
	self do: [:i | stream nextPut: (Character value: i)]! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new: aNumber
	^ (super new: aNumber) initialize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 00:09'!
fromString: aString
	| id |
	id _ super new: aString size.
	aString withIndexDo: [:ea :i | id at: i put: ea asInteger].
	^ id
! !

Object subclass: #WAController
	instanceVariableNames: 'continuation delegate '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

!WAController methodsFor: 'convenience' stamp: 'avi 12/10/2003 13:01'!
validateWith: aBlock
	^ WAValidationFrame new
		contents: self;
		validateWith: aBlock! !

!WAController methodsFor: 'rendering' stamp: 'ab 6/3/2003 01:17'!
renderActiveControllerWithContext: aContext
	|del|
	del _ self delegate.
	del
		ifNil: [self renderWithContext: aContext]
		ifNotNil: [del renderActiveControllerWithContext: aContext]! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:22'!
defaultSessionClass
	^ WASession! !

!WAController methodsFor: 'convenience' stamp: 'ab 2/18/2003 20:30'!
session
	^ WASession currentSession! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 18:23'!
registerAsApplication: appName
	|app|
	app _ self applicationWithPath: appName.
	WADispatcher default registerEntryPoint: app at: appName.
	^ app! !

!WAController methodsFor: 'convenience' stamp: 'ab 2/20/2003 19:41'!
inform: aString
	self call: (WADialog message: aString)
! !

!WAController methodsFor: 'call/answer' stamp: 'ab 6/24/2003 16:10'!
willCall
	^ true! !

WAController subclass: #WAComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

WAComponent subclass: #WATrail
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WATrail methodsFor: 'as yet unclassified' stamp: 'avi 9/17/2003 11:36'!
renderContentOn: html
	| list |
	list _ self controllersAndNames.
	list isEmpty ifTrue: [^ self].
	
	list do:
		[:assoc |
		assoc key = root activeController
			ifTrue: [html text: assoc value]
			ifFalse: [html anchorWithAction: [self backtrackTo: assoc key] text: assoc value].
		assoc = list last ifFalse: [html text: ' >> ']]! !

!WATrail class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root _ anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:56'!
backtrackTo: aController
	aController clearDelegate! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:55'!
controllersAndNames
	| list object |
	list _ OrderedCollection new.
	object _ root.
	[object isNil] whileFalse:
		[(object respondsTo: #trailName)
			ifTrue: [list add: object -> object trailName].
		 object _ object delegate].
	^ list! !

WAComponent subclass: #WAPackagePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAPackagePanel methodsFor: 'as yet unclassified' stamp: 'ab 2/2/2003 22:07'!
renderContentOn: html
	html form: [
		html table: [
			PackageManager allManagers do:
				[:ea |
				html tableRowWithLabel: ea packageName
						column: [self renderDirectoryEditorForPackage: ea on: html]]
		]
	].
	html anchorWithAction: [Smalltalk snapshot: true andQuit: false] text: 'Save Image'.! !

!WAPackagePanel methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:31'!
renderDirectoryEditorForPackage: aManager on: html
		html
			attributeAt: 'size' put: 50;
			textInputWithValue: aManager directory fullName
			callback: [:path | aManager directory: (FileDirectory on: path)].
		html space.
		html submitButtonOn: #fileIn of: aManager.! !

WAComponent subclass: #WACounter
	instanceVariableNames: 'count '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WACounter methodsFor: 'method-editor' stamp: ''!
increment
	count _ count + 1! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 01:07'!
initialize
	(self registerAsApplication: 'counter')
! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 23:01'!
initialize
	self session registerObjectForBacktracking: self.
	count _ 0! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 14:38'!
decrement
  count _ count - 1! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 1/4/2003 22:28'!
renderContentOn: html
	html heading: count.
	html anchorWithAction: [self increment] text: '++'.
	html space.
	html anchorWithAction: [self decrement] text: '--'! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
renderHeaderOn: aRenderer
	aRenderer render: self header! !

WAComponent subclass: #WAExplorer
	instanceVariableNames: 'root tree tabs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAExplorer class methodsFor: 'as yet unclassified' stamp: 'ab 6/3/2003 00:49'!
on: aComponent
	^ self new root: aComponent! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:03'!
style
	^'
#explorer-tree {
	vertical-align: top;
	padding: 10px;
	font-size: 10pt;
	background-color: lightgrey;
	width: 20%;
}

#explorer-contents {
	padding: 10px;
}
'! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
target: aComponent
	| tabName activeComponent|
	tabName _ tabs contents ifNotNilDo: [:c | c selectedTabName].
	activeComponent _ aComponent activeController.
	tabs contents:
		(WATabPanel withAll:
			(Array
				with: #view -> activeComponent
				with: #source -> (WAPrettyPrinter on: activeComponent)
				with: #inspect -> (WAInspector on: activeComponent))).
				
	tabName ifNotNil: [tabs contents selectTabNamed: tabName].		! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
root: aComponent
	root _ aComponent.
	tree _ WAComponentTree on: root.
	tree onAnswer: [:c | self target: c].
	self target: root.! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
renderContentOn: html
	html table: [
		html tableRow:
			[html cssId: 'explorer-tree'.
			html tableData: [html render: tree].
			
			html cssId: 'explorer-contents'.
			html tableData: [html render: tabs contents]]]! !

!WAExplorer methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:52'!
initialize
	tabs _ WAStateHolder new! !

WAComponent subclass: #WAInputTest
	instanceVariableNames: 'nilString integer emptyString fraction '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:39'!
renderContentOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value PrintString);
				tableRowWithLabel: 'Nil String'
					column: [html textInputOn: #nilString of: self]
					column: [html text: nilString printString];
				tableRowWithLabel: 'Empty String'
					column: [html textInputOn: #emptyString of: self]
					column: [html text: emptyString printString];
				tableRowWithLabel: 'Integer'
					column: [html textInputOn: #integer of: self]
					column: [html text: integer printString];
				tableRowWithLabel: 'Fraction'
					column: [html textInputOn: #fraction of: self]
					column: [html text: fraction printString].
		].
		html submitButton.
	]
! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer
	^integer! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString: anObject
	nilString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer: anObject
	integer := anObject! !

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 23:04'!
initialize
	nilString _ nil.
	emptyString _ ''.
	integer _ 42.
	fraction _ 1/3.! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString: anObject
	emptyString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString
	^emptyString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString
	^nilString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction: anObject
	fraction := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction
	^fraction! !

WAComponent subclass: #WAConfigurationEditor
	instanceVariableNames: 'configuration '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Configuration'!

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:11'!
renderInheritedAttribute: anAttribute on: html
	html anchorWithAction: [configuration overrideAttribute: anAttribute] text: 'edit'.
	html space.
	html text: (configuration valueForAttribute: anAttribute) printString! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:25'!
visitListAttribute: anAttribute with: html
	html
		selectFromList: anAttribute options
		selected: (configuration valueForAttribute: anAttribute)
		callback: [:v | (configuration takeValue: v forAttribute: anAttribute)]! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:46'!
initialize
	configuration _ WAConfiguration new! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:24'!
visitBooleanAttribute: anAttribute with: html
	html
		booleanMenuWithValue:  (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v forAttribute: anAttribute]! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:43'!
renderContentOn: html
	configuration ancestors do:
		[:ea |
		html tableRowWithLabel: 'Base Configuration:' column: [self renderParent: ea on: html]].
	self possibleParents isEmpty ifFalse:
		[html tableRowWithLabel: 'Add:' column: [self renderParentSelectorOn: html]].
	html spacerRow.
	configuration allAttributes do: 
		[:attr |
		html
			tableRowWithLabel: (html labelForSelector: attr key)
			column: [self renderAttribute: attr on: html]]! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'jf 2/1/2004 18:56'!
renderUnspecifiedAttribute: anAttribute on: html
	anAttribute accept: self with: html.
	html space.
	html attributes style: 'color: #ff0000'.
	html span: [html text: '(unspecified)']! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:14'!
visitStringAttribute: anAttribute with: html
	html
		textInputWithValue: (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v forAttribute: anAttribute]! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:35'!
renderParentSelectorOn: html
	|selectedBase|
	selectedBase _ ValueHolder new.
	html
		selectFromList: self possibleParents
		selected: nil
		callback: [:v | selectedBase contents: v]
		labels: [:ea | ea name].
	html
		submitButtonWithAction: [configuration addAncestor: selectedBase contents]
		text: 'OK'. ! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'jf 2/1/2004 13:34'!
renderOverridenAttribute: anAttribute on: html
	anAttribute accept: self with: html.
	html space.
	html anchorWithAction: [configuration clearValueForAttribute: anAttribute] text: 'clear'.
	html space.
	html text: '(', (configuration lookupValueForAttribute: anAttribute) printString, ')'! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'jf 2/1/2004 18:03'!
possibleParents
	^ WAConfiguration registry reject:
		[:ea |
		configuration inheritsFrom: ea]! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'jf 2/1/2004 18:53'!
renderAttribute: anAttribute on: html
	(configuration valueForAttribute: anAttribute)
		ifNil: [self renderUnspecifiedAttribute: anAttribute on: html]
		ifNotNil: 
			[(configuration hasLocalValueForAttribute: anAttribute)
				ifTrue: [self renderOverridenAttribute: anAttribute on: html]
				ifFalse: [self renderInheritedAttribute: anAttribute on: html]]! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:02'!
configuration: aConfiguration
	configuration _ aConfiguration! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:35'!
renderParent: aConfiguration on: html
	html
		anchorWithAction: [configuration removeAncestor: aConfiguration] 
		text: '-'.
	html space.
	html text: aConfiguration name! !

!WAConfigurationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:25'!
visitNumberAttribute: anAttribute with: html
	html attributes size: 5.
	html
		textInputWithValue: (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v asNumber forAttribute: anAttribute]! !

WAComponent subclass: #WAHtmlTest
	instanceVariableNames: 'booleanList message number '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderCheckboxesOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc |
			html text: assoc key; space.
			html checkboxWithValue: assoc value callback: [:b | assoc value: b].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 20:06'!
renderTextInputOn: html
		html form: [
			html text: message.
			html paragraph.
			html textInputWithValue: message callback: [:v | message _ v].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		html divClass: 'row' with: [
			html divClass: 'left' with: [self perform: selA with: html].
			html divClass: 'left' with: [self perform: selB with: html]
		]]
! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderSelectsOn: html
		html text: number.
		html paragraph.
		html form: [
			html selectFromList: (1 to: 10) selected: number callback: [:i | number _ i].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 20:07'!
renderZ: html
	html space! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderRadioButtonsOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc | |group|
			group _ html radioGroup.
			html text: assoc key; space.
			html radioButtonInGroup: group selected: assoc value callback: [assoc value: true].
			html radioButtonInGroup: group selected: assoc value not callback: [assoc value: false].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 11/23/2002 12:19'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderSubmitButtonsOn: html
		html text: number.
		html paragraph.
		html form: [
			(1 to: 10) do:
				[:i |
				html submitButtonWithAction: [number _ i] text: i.
				html space]
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:59'!
renderTextAreaOn: html
		html form: [
			html text: message.
			html paragraph.
			html textAreaWithValue: message callback: [:v | message _ v].
			html break; submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:42'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		yourself! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:43'!
initialize
	message _ 'Hello world!!'.
	booleanList _ #(a b c d) collect: [:k | k -> ((Array with: true with: false) atRandom)].
	number _ 10 atRandom.! !

WAComponent subclass: #WAToolFrame
	instanceVariableNames: 'child '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'jf 1/12/2004 16:45'!
style
^'
	#toolbar {position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	#toolbar-profile {margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
'! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:08'!
renderContentOn: html 
	html divNamed: 'frameContent' with: child.
	self renderToolbarOn: html.! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 9/16/2003 12:57'!
newSession
	self session expire! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:16'!
renderToolbarOn: html 
	html paragraph.
	html 
		divNamed: 'toolbar'
		with: 
			[self actions do:
				[:ea |
				html anchorOn: ea of: self; space].
			self tools do:
				[:ea |
				html anchorWithAction: [self openTool: ea] text: ea linkText; space]]! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:19'!
actions
	^ #(newSession configure)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:52'!
tools
	^ WATool allSubclasses! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:20'!
configure
	self call: (WAApplicationEditor new application: self session application)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:53'!
openTool: aToolClass
	self call: (WAWindow new
				title: aToolClass title;
				content: (aToolClass new root: child))! !

!WAToolFrame class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:26'!
on: aComponent
	^ self new contents: aComponent! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:52'!
contents: aComponent
	child _ aComponent! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 15:26'!
container
	^ child! !

WAComponent subclass: #WAApplicationEditor
	instanceVariableNames: 'application configEditor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Configuration'!

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 11:56'!
renderPreference: aPreference on: html
	html
		tableRowWithLabel: (html labelForSelector: aPreference key)
		column: aPreference! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 3/20/2003 12:14'!
sessionClasses
	^ (WASession allSubclasses asSortedCollection: [:x :y | x name < y name])! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 01:01'!
done
	self answer! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 18:19'!
renderContentOn: html
	html heading: 'Application: ', application name.
	html form: [
	].
	html paragraph.
	html form: [
		html table: [		
			html render: configEditor.
		
			html spacerRow.
			html
				tableRowWithLabel: 'Base Path'
				column: [html textInputOn: #basePath of: application].

			html spacerRow.
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #save of: self.
				html submitButtonOn: #done of: self.		
			] span: 2.
		]
	]! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:18'!
save! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:02'!
application: anApplication
	application _ anApplication.
	configEditor _ WAConfigurationEditor new configuration: application configuration! !

WAComponent subclass: #WAStoreItemView
	instanceVariableNames: 'item cart '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreItemView commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for viewing an individual WAStoreItem.  The caller must provide #item: and also the current #cart:.  Shows the description and price info for the item, and presents two buttons: "Add to Cart", which will add the item to the cart, once, and "Done", which will answer back to the caller.  Used by WAStoreFillCart>>displayItem: and displayItems:.!

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2003 23:36'!
renderContentOn: html
	html heading: item title.
	html heading: item subtitle level: 3.
	html paragraph: item description.
	html italic: item price printStringAsCents.
	html form: [
		html submitButtonWithAction: [self addToCart] text: 'Add to Cart'.
		html submitButtonWithAction: [self answer] text: 'Done'.
	]! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 14:47'!
item: anItem
	item _ anItem! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:11'!
addToCart
	cart add: item! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:11'!
cart: aCart
	cart _ aCart! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 5/31/2003 15:40'!
renderWithContext: aRenderingContext
	self renderAllOn: (self rendererClass fromContext: aRenderingContext)! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:17'!
target
	^ owner activeController! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector _ aSymbol! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:45'!
renderInput: aSymbol on: html
	html form: [
		html bold: aSymbol capitalized.
		html space.
		html textInputWithValue: '' callback: [:v | self target perform: aSymbol with: v].
	]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:44'!
renderLink: aSymbol on: html
	html anchorOn: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:43'!
renderContentOn: html
	self actions do:
		[:symbol |
		symbol numArgs = 0
			ifTrue: [self renderLink: symbol on: html]
			ifFalse: [self renderInput: symbol on: html]]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
owner: anObject
	owner _ anObject! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:13'!
initialize
	actionsSelector _ #actions! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:09'!
initialize
	stack _ #().
	self session registerObjectForBacktracking: self.! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:09'!
renderContentOn: html
	stack isEmpty ifTrue: [^ self].
	
	html divNamed: 'path' with: [
		stack allButLast do:
			[:assoc |
			html anchorWithAction: [self choose: assoc] text: assoc key.
			html text: ' >> '].
		
		html bold: stack last key].! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack _ stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:16'!
choose: anAssociation
	| newStack |
	newStack _ Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack _ newStack contents. ^ self]]
! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:36'!
header
	^ nil! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 5/31/2003 15:40'!
rendererClass
	^ WAHtmlRenderer! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 01:45'!
initialize
	self model: Browser new.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 12/12/2002 00:39'!
renderContentPaneOn: html
	html form: [
		html
			textAreaOn: #contents of: self;
			break;
			submitButtonOn: #accept of: self.
	]! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:50'!
contents
	^contents! !

!WABrowser methodsFor: 'rendering' stamp: 'JF 5/26/2003 13:30'!
style

	^ '

	#contents {width: 80%; height: 200px; font-family: serif; font-size: 12pt}

	'! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:36'!
notify: aString at: location in: sourceStream
	message _ aString allButLast: 3! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:42'!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:09'!
renderModeButtonsOn: html
	html form: [
		html
			submitButtonWithAction: [ self showInstance ] text: 'instance';
			submitButtonWithAction: [ self showHelp ] text: 'help';
			submitButtonWithAction: [ self showClass ] text: 'class' ]! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
select! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:38'!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:39'!
showInstance
	self model indicateInstanceMessages! !

!WABrowser class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:35'!
fullOnClass: aClass
	^ self new model: (Browser new setClass: aClass selector: nil)! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
selectFrom: aPos to: anotherPos
! !

!WABrowser methodsFor: 'actions' stamp: 'ab 12/12/2002 00:40'!
accept
	|save|
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: (self request: 'Please enter your initials:' default: '')].
	message _ nil.
	save _ contents.
	model contents: contents notifying: self.
	contents _ save.
! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 2/16/2003 00:26'!
renderMessageOn: html
	message ifNotNil: [html bold: message]! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 22:13'!
model
	^model 
! !

!WABrowser methodsFor: 'actions' stamp: 'ab 10/10/2002 01:45'!
update: aSymbol
	contents _ model contents! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:07'!
model: aBrowserModel
	model _ aBrowserModel.
	model addDependent: self.
	self session registerObjectForBacktracking: model.
	contents _ model contents.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	self
		renderColumnsOn: html;
		renderModeButtonsOn: html;
		renderMessageOn: html;
		renderContentPaneOn: html
	! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:41'!
columnView: columnName
	^WAPluggableSelectBox
		on: model
		list: (columnName, 'List') asSymbol
		selected: (columnName, 'ListIndex') asSymbol
		changeSelected: (columnName, 'ListIndex:') asSymbol! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:54'!
contents: aString
	contents _ aString! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:08'!
renderColumnsOn: html
	|cols|
	cols _ #(systemCategory class messageCategory message)
				collect: [:sel | self columnView: sel].

	html table: [
		html tableRow: [
			cols do: [:ea | html tableData: [html render: ea]].
		]
	]! !

WAComponent subclass: #WAMemoryUse
	instanceVariableNames: 'instances sizes table root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:41'!
totalSize
	^ sizes detectSum: [:ea | ea]! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:36'!
buildTable
	^ WATableReport new
			rowPeriod: 1;
			rowColors: #('lightgrey' 'white');
			rows: sizes keys asSortedCollection;
			columns: 
				(Array with: (WAReportColumn selector: #yourself title: 'Class')
				with: ( WAReportColumn new
					title: 'Instances';
					valueBlock: [:ea | instances at: ea])
				with:
				 (WAReportColumn new
					title: 'Total Size';
					valueBlock: [:ea | sizes at: ea]))
! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:58'!
totalSizeString
	|size unit|
	size _ self totalSize.
	unit _ 'bytes'.
	size > 1024 ifTrue:
		[size _ size / 1024.
		unit _ 'kB'.
		size > 1024 ifTrue:
			[size _ size / 1024.
			unit _ 'MB']].
	^ (size printShowingDecimalPlaces: 1), ' ', unit! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	html bold: self totalInstances asString, ' instances in ', self totalSizeString.
	html render: table.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 02:18'!
root: anObject
	|segment results|
	root _ anObject.
	segment _ ImageSegment new copyFromRoots: (Array with: root) sizeHint: 100000.
	results _ segment doSpaceAnalysis.
	instances _ results first.
	sizes _ results second.
	table _ self buildTable.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:42'!
totalInstances
	^ instances detectSum: [:ea | ea]! !

WAComponent subclass: #WAValidationFrame
	instanceVariableNames: 'message contents validationBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAValidationFrame methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock _ aBlock! !

!WAValidationFrame methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:50'!
initialize
	message _ WAStateHolder new! !

!WAValidationFrame methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:50'!
validate: anObject
	[validationBlock value: anObject.
	self answer: anObject]
		on: Error
		do: [:e | message contents: e messageText]! !

!WAValidationFrame methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:04'!
renderContentOn: html
	message contents ifNotNilDo:
		[:msg |
		html divClass: 'validation-error' with: msg].
	html render: contents.! !

!WAValidationFrame methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:49'!
contents: aComponent
	contents _ aComponent.
	contents onAnswer: [:v | self validate: v].! !

WAComponent subclass: #WAParentTest
	instanceVariableNames: 'parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:14'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'swap parent' ! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
parent: aComponent
	parent _ aComponent! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
go
	parent inform: 'foo'! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
renderFooterOn: aRenderer
	aRenderer render: self footer! !

WAComponent subclass: #WAErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAErrorTest methodsFor: 'as yet unclassified' stamp: 'ab 3/28/2003 16:47'!
renderContentOn: html
	html anchorWithAction: [1/0] text: 'Raise error'! !

WAComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:01'!
allClasses
	^ (WAController allSubclasses select: [:ea | ea class selectors anySatisfy: [:s | s beginsWith: self selectorPrefix]])
		asSortedCollection: [:a :b | a name < b name]! !

!WAExampleBrowser class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:10'!
initialize
	self registerAsApplication: 'examples'! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:01'!
allSelectors
	^ (class class selectors select: [:s | s beginsWith: self selectorPrefix])
		asSortedCollection! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:33'!
component: aComponent
	component _ aComponent.
	hasAnswer _ false.
	answer _ nil.
	component onAnswer: [:v | hasAnswer _ true. answer _ v].
! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
selectorPrefix
	^ 'example'! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:04'!
selector: aSymbol
	selector _ aSymbol.
	self component: (class perform: selector)! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:54'!
class: aClass
	class _ aClass.
	self selector: self allSelectors first! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:53'!
initialize
	self class: self allClasses first! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:40'!
renderContentOn: html
	html cssId: 'test-forms'; table: [
		html tableRowWith: [
			html form: [
				html selectFromList: self allClasses selected: class callback: [:c | self class: c].
				html submitButtonWithText: 'OK'.
			].
		] with: [
			html form: [
				html selectFromList: self allSelectors selected: selector callback: [:s | self selector: s].
			 	html submitButtonWithText: 'OK'.
			]
		].
	].
	html horizontalRule.
	html render: component.
	hasAnswer ifTrue:
		[html horizontalRule.
		html bold: 'Answer '; text: answer printString]! !

WAComponent subclass: #WACalendarTest
	instanceVariableNames: 'calendar range '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:59'!
updateCalendar
	calendar startDate: range startDate.
	calendar endDate: range endDate.! !

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:01'!
initialize
	range _ WADateRangeSelector new.
	range addDependent: self.
	calendar _ WADateTable new rows: #('a' 'b' 'c').
	self updateCalendar.! !

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:02'!
renderContentOn: html
	html render: range.
	html horizontalRule.
	html render: calendar! !

!WACalendarTest class methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:01'!
initialize
	self registerAsApplication: 'calendar'! !

!WACalendarTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:59'!
update: aSymbol	
	self updateCalendar! !

WAComponent subclass: #WAInspector
	instanceVariableNames: 'path '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:11'!
initialize
	path _ WAPath new! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:28'!
renderMembersOn: html 
	| members |
	members := self object inspectorFields.
	members isEmpty ifTrue: [^self].
	html bold: 'Members: '.
	html attributeAt: 'border' put: 1.
	html table: 
			[members associationsDo: 
					[:assoc | 
					self 
						renderRowForObject: assoc value
						named: assoc key
						on: html]]! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'jf 11/12/2003 16:32'!
renderContentOn: html 
	super renderContentOn: html.
	html render: path.
	html heading: (self object printStringLimitedTo: 50).
	html text: 'Identity Hash: ', self object identityHash asString; break; break.
	self renderMembersOn: html.! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:37'!
canInspect: anObject
	^ anObject isNumber or: [(Array with: nil with: true with: false) includes: anObject]! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:12'!
object
	^ path currentSegment! !

!WAInspector class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 00:21'!
on: anObject
	^ self new object: anObject! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:12'!
renderRowForObject: anObject named: aString on: html
	html tableRow: [
		html tableData: [ 
			(self canInspect: anObject)
				ifTrue: [html text: aString]
				ifFalse: [html anchorWithAction: [self chooseObject: anObject named: aString] text: aString ]
		].
		html tableData: [ html text: (anObject printStringLimitedTo: 100) ]
	]
	! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:11'!
object: anObject 
	path pushSegment: anObject name: anObject printString! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:13'!
chooseObject: anObject named: aString
	path pushSegment: anObject name: aString! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
style
	^ nil! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 6/13/2003 12:27'!
renderHeadElementsOn: aRenderer
	self style ifNotNilDo: [:style | aRenderer linkWithStyle: style].
	self script ifNotNilDo: [:script | aRenderer linkWithScript: script]! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:18'!
items: aCollection
	batcher _ WABatchedList new items: aCollection; batchSize: 8! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:38'!
renderContentOn: html
	html list: batcher batch do:
		[:ea |
		html anchorWithAction: [self choose: ea] text: (ea perform: linkSelector).
		html break; text: (ea perform: textSelector).
		html paragraph].
	html attributes alignCenter.
	html div: batcher.! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector _ aSymbol! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector _ aSymbol! !

!WABatchSelection class methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:23'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector! !

WAComponent subclass: #WAProfiler
	instanceVariableNames: 'child '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAProfiler methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:09'!
child: aComponent
	child _ aComponent! !

!WAProfiler methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:11'!
renderContentOn: html
	| data |
	data _ SeasidePlatformSupport profileSendsDuring: [html render: child].
	html horizontalRule.
	html preformatted: data.! !

WAComponent subclass: #WAStoreCartView
	instanceVariableNames: 'cart '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreCartView commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component for displaying and modifying a WAStoreCart.  Intended to be embedded rather than called.  The parent must provide a cart instance with #cart:.  Displays a list of items in the cart, and allows individual items to be removed.  Used by WAStoreFillCart.!

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:03'!
renderContentOn: html
	cart hasItems ifFalse: [^ self].
	html divNamed: 'cart' with: [
		html small: [html bold: 'Your cart:'].
		html table: [
			cart countsAndItems do:
				[:assoc | self renderRowForCount: assoc key of: assoc value on: html ].
			html spacerRow.
			html
				tableRowWith: ''
				with: ''
				with: [html bold: cart totalPrice printStringAsCents].
		]
	]! !

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:18'!
cart: aCart
	cart _ aCart! !

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
renderRowForCount: aNumber of: anItem on: html 
	| countString |
	countString _ (aNumber = 1) ifTrue: [''] ifFalse: ['(', aNumber asString, ') '].
	html
		tableRowWith: [html anchorWithAction: [cart remove: anItem] text: '-']
		with: countString, anItem title 
		with: (aNumber * anItem price) printStringAsCents! !

WAComponent subclass: #WAWalkback
	instanceVariableNames: 'exception '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:08'!
renderStackFrame: aContext on: html
	html li: [
		html text: aContext fullPrintString.
		html blockquote: [ html table: [
			self renderObject: aContext receiver labelled: 'self' on: html.
			aContext tempNames withIndexDo:
			[:name :index |
			self renderObject: (aContext tempAt: index) labelled: name on: html].
		]]
	]! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:54'!
debug
	self answer! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:09'!
renderObject: anObject labelled: aString on: html
	| objectString |
	[objectString _ anObject printStringLimitedTo: 100]
		on: Error
		do: [objectString _ '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	html tableRowWithLabel: aString column: objectString.! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:52'!
exception: anException
	exception _ anException! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 23:16'!
renderWalkbackOn: html
	|context|
	html heading: exception description.
	html ul: [
		context _ thisContext. 
		[context receiver isKindOf: Exception] whileFalse: [context _ context sender].
		[context receiver isKindOf: Exception] whileTrue: [context _ context sender].
		[context notNil] whileTrue: [
			self renderStackFrame: context on: html.
			context _ context sender].
	]! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:09'!
renderContentOn: html
	html anchorWithAction: [self debug] text: 'Debug'.
	self renderWalkbackOn: html.! !

WAComponent subclass: #WAStore
	instanceVariableNames: 'task '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStore commentStamp: 'avi 1/1/2004 10:06' prior: 0!
This component is the entry point for the store example.  It provides the main stylesheet in its #style method, renders a simple banner at the top, and then embeds an instance of WAStoreTask, which is where the real action happens.!

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
subtitle
	^ 'fresh, raw fish delivered to your door'! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:11'!
style
	^ '
	body {margin: 0px; font-family: sans-serif}
	#banner {width: 100%}	
	#banner tr {background-color: lightblue; text-align: right; padding: 10px; vertical-align: bottom}
	#title {font-size: 18pt; font-weight: bold}
	#subtitle {font-size: 9pt; font-style: italic}
	#body {padding: 5px}
	.validation-error {color: red; font-size: 9pt; padding: 5px}
	'
! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:50'!
renderContentOn: html
	html cssId: 'banner'.
	html table: [
		html tableRowWith: [
			html divNamed: 'title' with: self title.
			html divNamed: 'subtitle' with: self subtitle.
		]
	].
	html divNamed: 'body' with: task! !

!WAStore class methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
initialize
	self registerAsApplication: 'store'! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:59'!
initialize
	task _ WAStoreTask new.! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
title
	^ 'sushiNet'! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
renderContentOn: aRenderer! !

WAComponent subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:02'!
renderContentOn: html
	html form: [
		html submitButtonWithAction: [self answer: true] text: 'Yes'.
		html space.
		html submitButtonWithAction: [self answer: false] text: 'No'.
	]! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 6/13/2003 12:26'!
script
	^ nil! !

WAComponent subclass: #WAStoreAddressEditor
	instanceVariableNames: 'address '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreAddressEditor commentStamp: 'avi 1/1/2004 09:56' prior: 0!
A component for editing WAStoreAddress instances.  When called, it will create a new address instance, present a form for the user to modify it, and then answer the instance on submit.  Used by WAStoreTask>>getBillingAddress and getShippingAddress.!

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:55'!
renderContentOn: html
	html form: [
		html table: [
			html labelledRowForTextInputOn: #name of: address.
			html labelledRowForTextInputOn: #street of: address.
			html labelledRowForTextInputOn: #city of: address.
			html labelledRowForList: self countries on: #country of: address.
			html spacerRow.
			html attributes alignCenter.
			html tableRowWith: [html submitButtonWithAction: [self ok] text: 'OK'] span: 2.
		].
	]! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:54'!
initialize
	address _ WAStoreAddress new.! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:04'!
ok
	self answer: address! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:55'!
countries
	^ #(Canada USA)! !

WAComponent subclass: #WADateSelectionDialog
	instanceVariableNames: 'selector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
footer
	^ nil! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WAReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:29'!
initialize
	rows _ #().
! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WATableReport methodsFor: 'rendering' stamp: 'JF 2/3/2003 00:01'!
renderHeaderForColumn: aColumn on: html
	html tableHeading: [
		aColumn canSort
			ifTrue: [
				html anchorWithAction: [self sortColumn: aColumn] text: aColumn title]
			ifFalse: [
				html text: aColumn title]
	]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns _ anArray! !

!WATableReport methodsFor: 'state variables' stamp: 'AC 1/31/2003 11:46'!
sortColumn: anObject 
	anObject = self sortColumn
		ifTrue: [isReversed _ isReversed not]
		ifFalse: [isReversed _ false].
	sortColumn contents: anObject! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r _ self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableHeaderOn: html
	html tableRow: [ columns do: [ :ea | self renderHeaderForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod _ aNumber! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 1/31/2003 11:26'!
renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableFooterOn: html
	html tableRow: [ columns do: [ :ea | self renderFooterForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:01'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber-1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderContentOn: html
	html attributeAt: 'cellspacing' put: 0; attributeAt: 'cellpadding' put: 5.
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html.
	]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors _ colorArray! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderRowNumber: index item: row on: html
	html attributeAt: 'bgcolor' put: (self colorForRowNumber: index).
	html tableRow: [ columns do: [:ea | self renderColumn: ea row: row on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:06'!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 11/11/2002 19:04'!
chooseRow: aRow column: aColumn	
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 2/3/2003 12:41'!
renderColumn: aColumn row: aRow on: html
	|text|
	text _ aColumn textForRow: aRow.
	text isEmpty ifTrue: [text _ '&nbsp;'].
	html tableData: [
		aColumn canChoose
			ifFalse: [html text: text]
			ifTrue: [html anchorWithAction: [self chooseRow: aRow column: aColumn] text: text]
	]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 11/12/2002 14:32'!
renderFooterForColumn: aColumn on: html
	html tableHeading: [ html text: (aColumn totalForRows: rows)]
! !

!WAReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:03'!
rows: anArray
	rows _ anArray! !

WAComponent subclass: #WAStoreInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreInfo commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component that displays simple informative text about this example.  Used by WAStoreFillCart.!

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:29'!
text
	^
'Welcome to the sushiNet online store.
<p>
This is a sample Seaside application.
<p>
Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".
'! !

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 12:10'!
renderContentOn: html
	html text: self text! !

WAComponent subclass: #WAComponentTree
	instanceVariableNames: 'components root selection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:32'!
renderChildrenOf: aComponent on: html
	html ul: [ 
		aComponent class allInstVarNames do:
			[:name | |ivar|
			ivar _ aComponent instVarNamed: name.
			(ivar isKindOf: WAController)
				ifTrue: [self renderBranch: ivar named: name on: html]
				ifFalse: [((ivar isCollection
							and: [ivar isEmpty not])
							and: [ivar allSatisfy: [:ea | ea isKindOf: WAComponent]])
								ifTrue: [self renderCollection: ivar named: name on: html]]]
	]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:26'!
root: aComponent
	root _ aComponent.
	selection _ WAStateHolder new contents: root.! !

!WAComponentTree class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 00:20'!
on: aComponent
	^ self new root: aComponent! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:15'!
renderTree: aComponent on: html
	(components includes: aComponent) ifFalse:
		[components add: aComponent.
		self renderChildrenOf: aComponent activeController on: html]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:50'!
renderLink: aComponent named: nameString on: html
	aComponent == self selection
		ifTrue: [html bold: [html anchorWithAction: [selection contents: aComponent. self answer: aComponent activeController] text: nameString]]
		ifFalse: [html anchorWithAction: [selection contents: aComponent.  self answer: aComponent] text: nameString]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:38'!
renderCollection: aCollection named: nameString on: html
	html li:
		[html text: nameString.
		html ol: [aCollection do: [:ea | html li: [self renderTree: ea on: html]]]]! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:26'!
renderContentOn: html
	components _ Set new.
	self renderLink: root named: 'root' on: html.
	self renderTree: root on: html! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:21'!
selection
	^ selection contents! !

!WAComponentTree methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:26'!
renderBranch: aComponent named: nameString on: html
	(components includes: aComponent) ifTrue: [^ self].
	html li: [
		self renderLink: aComponent named: nameString on: html.
		self renderTree: aComponent on: html
	]! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 18:58'!
loadURL
	| stream version |
	stream _ url asUrl retrieveContents content asByteArray readStream .
	version _ (MCVersionReader readerClassForFileNamed: url) versionFromStream: stream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'ab 8/30/2003 20:55'!
saveImage
	Smalltalk snapshot: true andQuit: false! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 18:58'!
loadFile
	| reader version |
	reader _ MCVersionReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version _ reader versionFromStream: file contents asByteArray readStream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 8/30/2003 21:24'!
renderContentOn: html
	html bold: 'Loaded versions:'.
	html list: MCWorkingCopy allManagers do: [:ea | html text: ea description].
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html bold: 'Load version from file: '; break.
		html fileUploadWithCallback: [:f | file _ f].
		html space.
		html submitButtonWithAction: [self loadFile] text: 'Load'.
	].
	html form: [
		html bold: 'Load version from URL: '; break.
		html attributes size: 60.
		html textInputWithValue: 'http://' callback: [:u | url _ u].
		html space.
		html submitButtonWithAction: [self loadURL] text: 'Load'.
	].
	html anchorWithAction: [self saveImage] text: 'Save Image'. ! !

WAComponent subclass: #WATabPanel
	instanceVariableNames: 'selectedTab tabs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WATabPanel class methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:26'!
withAll: aCollection
	^ self new addTabs: aCollection! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 22:02'!
style
	^ ' .TabSelected {background-color: lightblue; font-color: white; width: 95; text-align: center}
		.TabUnselected {background-color: lightgrey; width: 95; text-align: center}
		.TabSpacer {width: 15}
		.TabLine {background-color: lightblue}
	'! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:38'!
addTab: aComponent named: aString
	tabs add: aString -> aComponent! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:49'!
renderTabSpacerOn: html
	html cssClass: 'TabSpacer'; tableData: [html space]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 15:44'!
selectTabNamed: aString
	selectedTab _ (Dictionary withAll: tabs) at: aString ifAbsent: [self selectedTab]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:39'!
selectedTab
	^ selectedTab ifNil: [selectedTab _ tabs first value]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:38'!
initialize
	tabs _ OrderedCollection new! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:50'!
renderTab: aComponent named: aString on: html
	|selected|
	selected _ aComponent == self selectedTab.
	html cssClass: (selected ifTrue: ['TabSelected'] ifFalse: ['TabUnselected']).
	html tableData: [
		selected
			ifTrue: [html text: aString]
			ifFalse: [html anchorWithAction: [selectedTab _ aComponent] text: aString]. 
	]! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 22:01'!
renderContentOn: html
	html table: [
		html tableRow: [
			self renderTabSpacerOn: html.
			tabs do:
				[:ea |
				self renderTabSpacerOn: html.
				self renderTab: ea value named: ea key on: html].
		].
		html cssClass: 'TabLine'.
		html tableRowWith: [html text: '<img width=1 height=1 alt="">'] span: tabs size * 4.
	].
	html break.
	html render: self selectedTab.! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 15:29'!
selectedTabName
	^ (tabs detect: [:assoc | assoc value = self selectedTab]) key! !

!WATabPanel methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:24'!
addTabs: aCollection
	aCollection associationsDo:
		[:ea |
		self addTab: ea value named: ea key]! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:41'!
default: aString
	value _ aString! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:12'!
renderContentOn: html
	html heading: message level: 3.
	html form: [
		html defaultAction: [self answer: value].
		html textInputWithValue: value callback: [:v | value _ v].
		html space.
		html submitButtonWithText: self label.
	]! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:10'!
label: aString
	label _ aString! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:12'!
label
	^ label ifNil: [label _ 'OK']! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
endDate: aDate
	endDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 15:12'!
renderContentOn: html
	html attributes border: 1.
	html cssClass: 'DateTable'; table: [
		html tableRow: [self renderMonthHeadingsOn: html].
		html tableRow: [self renderDayHeadingsOn: html].
		rows withIndexDo:
			[:ea :i|
			html tableRow: [self renderRow: ea index: i on: html]].
	]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:22'!
renderHeadingSpacerOn: html
	html tableData: []! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:51'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [:date | self renderCellForDate: date row: anObject index: aNumber on: html]	
		separatedBy: [	self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:14'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo:
		[:month :length |
		self renderHeadingSpacerOn: html.
		html
			cssClass: 'MonthHeading';
			attributeAt: 'colspan' put: length;
			tableHeading: [html text: month name; space; text: month year]]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart _ dateSelectionEnd _ aDate. rowSelectionStart _ rowSelectionEnd _ rowIndex]
		ifTrue: [dateSelectionEnd _ aDate. rowSelectionEnd _ rowIndex]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:04'!
selectAll
	dateSelectionStart _ startDate.
	dateSelectionEnd _ endDate.
	rowSelectionStart _ 1.
	rowSelectionEnd _ rows size.! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart _ dateSelectionEnd _ rowSelectionStart _ rowSelectionEnd _ nil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock _ aBlock! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:41'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	|text|
	html attributeAt: 'bgcolor' put: (self colorForDate: aDate rowIndex: aNumber).
	html attributeAt: 'align' put: 'center'.
	html tableData: [
		text _ cellBlock value: anObject value: aDate.
		html anchorWithAction: [self selectDate: aDate rowIndex: aNumber] text: text.
	]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:52'!
datesDo: aBlock separatedBy: monthlyBlock
	| month|
	month _ datesCache first monthIndex.
	datesCache do:
		[:date |
		date monthIndex = month ifFalse: [month _ date monthIndex. monthlyBlock value].
		aBlock value: date].
	monthlyBlock value.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
startDate: aDate
	startDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:20'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date | html cssClass: 'DayHeading'; tableHeading: [html text: date dayOfMonth]]
		separatedBy: [self renderHeadingSpacerOn: html]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows _ aCollection! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:50'!
renderHeadingForRow: anObject on: html
	html cssClass: 'RowHeading'; tableHeading: [html text: anObject]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:19'!
monthsAndLengthsDo: aBlock
	|count last|
	count _ 0.
	self
		datesDo: [:ea | count _ count + 1. last _ ea]
		separatedBy: [aBlock value: last month value: count.
						count _ 0]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:58'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].
	
	datesCache _ OrderedCollection new.
	date _ startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date _ date next]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

WAComponent subclass: #WAUploadTest
	instanceVariableNames: 'file '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAUploadTest methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 13:32'!
renderContentOn: html
	html heading: 'Upload File'.
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html fileUploadWithCallback: [:f | file _ f].
		html submitButton.
	].

	file ifNotNil:
		[html anchorWithDocument: file contents mimeType: 'application/octet-stream' fileName: file fileName text:file fileName.
		html preformatted: file contents contents].! !

WAComponent subclass: #WAEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAEncodingTest methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:30'!
renderContentOn: html
	| w allChars r |

	w := WriteStream on: String new.
	32 to: 255 do: [ :c |  w nextPut: c asCharacter ].
	allChars := w contents.

	html code: [ 
		html text: 'Start'; break.
		r := ReadStream on: allChars.

		[ r atEnd ] whileFalse: [ 
			html encodeText: (r next: 14);
			break.
		].
		html text: 'End'; 
			  break.
	].
	html text: 'Characters Encoded: '.
	'Hello World' do: [ :c | html encodeCharacter: c ]. 
	html break.
! !

WAComponent subclass: #WAStoreCartConfirmation
	instanceVariableNames: 'cart '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreCartConfirmation commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for confirming the contents of a WAStoreCart.  The caller must provide a cart instance with #cart: .  When called, it will display a summary of the items in the cart, along with two buttons: "Proceed with checkout" and "Modify cart".  Answers true if the user presses the first button, false if the user presses the seecond.  Used by WAStoreTask>>confirmContentsOfCart.!

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:35'!
cart: aCart
	cart _ aCart! !

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:03'!
renderContentOn: html
	html attributes border: 1.
	html table: [
		cart countsAndItems do:
			[:assoc | |count item|
			count _ assoc key.
			item _ assoc value.
			html tableHeadings: #(Item Price Count Total).
			html attributes align: #right.
			html tableRow: [
				html tableData: item title.
				html tableData: item price printStringAsCents.
				html tableData: count asString.
				html tableData: (item price * count) printStringAsCents.
			]].
		html attributes align: #right.
		html tableRowWith: [html bold: cart totalPrice printStringAsCents] span: 4.
	].
	html paragraph.
	html form: [
		html submitButtonWithAction: [self answer: true] text: 'Proceed with checkout'.
		html break.
		html submitButtonWithAction: [self answer: false] text: 'Modify my order'.
	]! !

WAComponent subclass: #WAWindow
	instanceVariableNames: 'title content style '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:53'!
style
	^ style ifNil: [self defaultStyle]! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 13:19'!
defaultStyle
^ '
	#window-titlebar {background-color: lightblue; margin-bottom: 10px; width: 100%; }
	#window-title { text-align: right; width: 66% }
	#window-close {text-align: right;}
'	! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:52'!
content: aComponent
	content _ aComponent! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title _ aString! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:54'!
style: aString
	style _ aString! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 23:55'!
renderCloseButtonOn: html
	html anchorWithAction: [self answer] text: 'close'! !

!WAWindow methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 13:23'!
renderContentOn: html
	html title: title.
	html attributes at: 'cellspacing' put: 0.
	html table: [
		html cssId: 'window-titlebar'; tableRow: [
				html cssId: 'window-title'; tableData: title.
				html cssId: 'window-close'; tableData: [self renderCloseButtonOn: html].
		].
		html cssId: 'window-content'; tableRowWith: content span: 2.	
	].! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:52'!
date: aDate
	day _ aDate dayOfMonth.
	month _ aDate monthIndex.
	year _ aDate year.! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 15:15'!
initialize
	startYear _ Date today year - 1.
	endYear _ Date today year + 5! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:28'!
date
	^ Date newDay: day monthNumber: month year: year! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:32'!
renderValidationErrorOn: html
	html spanClass: 'error' with: 'invalid date'! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
renderContentOn: html
	html selectFromList: self months selected: month callback: [:i | month _ i] labels: [:ea | self labelForMonth: ea].
	html selectFromList: self days selected: day callback: [:i | day _ i] labels: [:ea | self labelForDay: ea].
	html selectFromList: self yearRange selected: year callback: [:i | year _ i] labels: [:ea | self labelForYear: ea].
	
	self dateIsValid ifFalse: [self renderValidationErrorOn: html].! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

WAComponent subclass: #WATaskFrame
	instanceVariableNames: 'task '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tasks'!

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:19'!
initialize
	task _ WAPluggableTask withBlock: [:t | self go].
	task onAnswer: [:v | self answer: v]! !

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:44'!
call: aController
	^ task call: aController! !

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:39'!
renderContentOn: html
	html render: task! !

!WATaskFrame methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:09'!
go
	self subclassResponsibility! !

WAComponent subclass: #WADispatcherEditor
	instanceVariableNames: 'path dispatcher type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Configuration'!

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:34'!
remove: anEntryPoint
	dispatcher removeEntryPoint: anEntryPoint! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:52'!
entryPointClasses
	^ WAEntryPoint concreteSubclasses! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:49'!
initialize
	dispatcher _ WADispatcher default.
	type _ WAApplication.
	path _ ''.! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:48'!
configure: anEntryPoint
	 anEntryPoint configurationComponent ifNotNilDo: [:c | self call: c]! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:13'!
dispatcher: aDispatcher
	dispatcher _ aDispatcher! !

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:27'!
initialize
	self registerAsApplication: 'config'! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:49'!
addEntryPoint
	| entryPoint |
	path isEmpty ifTrue: [^ self inform: 'You must enter a path.'].
	entryPoint _ type new.
	dispatcher registerEntryPoint: entryPoint at: path.
	self configure: entryPoint! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'JF 9/22/2003 20:15'!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:33'!
renderRowForEntryPoint: anEntryPoint named: aString on: html
	html
		tableRowWith: [html anchorWithUrl: anEntryPoint basePath do: aString]
		with: [
			html anchorWithAction: [self configure: anEntryPoint] text: 'configure'.
			html space; anchorWithAction: [self remove: anEntryPoint] text: 'remove'.
		].! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:16'!
renderContentOn: html
	html heading: 'Squeak Enterprise Aubergines Server'.
	
	html bold: dispatcher basePath.
	html form: [
		html table: [
			dispatcher entryPoints keysAndValuesDo:
				[:name :each |
				self
					renderRowForEntryPoint: each
					named: name
					on: html].
		]
	].
	html paragraph.
	
	html bold: 'add entry point: '.
	html form: [
		html table: [
			html tableRowWithLabel: 'Path:' column: [html textInputWithValue: '' callback: [:n | path _ n]].
			html tableRowWithLabel: 'Type:' column:
				[html selectFromList: self entryPointClasses selected: type callback: [:c | type _ c] labels: [:ea | ea description].
				html space.
				html submitButtonWithAction: [self addEntryPoint] text: 'Add']
		]
	].

	continuation ifNotNil: [html anchorWithAction: [self answer] text: 'Done'].	
	html preformatted: SeasidePlatformSupport vmStatisticsReportString.
	html anchorWithAction: [self clearCaches] text: 'Clear Caches'.
	! !

WAComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
renderContentOn: html
	counters 
		do: [:ea | html render: ea]
		separatedBy: [html horizontalRule]! !

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:08'!
initialize
	self registerAsApplication: 'multi'! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
initialize
	counters _ (1 to: 5) collect: [:i | WACounter new]! !

WAComponent subclass: #WAIframeTest
	instanceVariableNames: 'current '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAIframeTest methodsFor: 'as yet unclassified' stamp: 'lr 1/5/2004 13:37'!
renderContentOn: html
	html heading: current.
	html anchorWithAction: [ current _ current + 1 ] text: 'inc'; break.
	html anchorWithAction: [ current _ current - 1 ] text: 'dec'; break.
	html break.
	html attributes style: 'border: solid blue 1px'.
	html iframe: [
		0 to: current do: [ :each |
			html anchorWithAction: [ current _ each ] text: each; break ] ]! !

!WAIframeTest methodsFor: 'as yet unclassified' stamp: 'lr 1/5/2004 13:39'!
initialize
	self session registerObjectForBacktracking: self.
	current _ 20! !

WAComponent subclass: #WAStoreFillCart
	instanceVariableNames: 'cart cartView main '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreFillCart commentStamp: 'avi 1/1/2004 10:10' prior: 0!
This component provides the main UI for browsing the store inventory and filling the cart.  The caller must provide a shopping cart instance with #cart:.  The component presents a navigation bar with options to browse and search on the left, and embeds a WACartView showing the cart contents on the right.  In the middle is initially embedded a WAStoreInfo.  Browsing and searching will replace this with a stock WABatchSelection component for listing items (see #displatItems:), or a WAStoreItemView for displaying individual items.  This answers back to the caller when the user chooses "checkout" from the nav bar.!

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:10'!
cart: aCart
	cart _ aCart.
	cartView cart: aCart.! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:53'!
initialize
	main _ WAStoreInfo new.
	cartView _ WAStoreCartView new! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:10'!
displayItem: anItem
	main call: (WAStoreItemView new item: anItem; cart: cart)! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
inventory
	^ WAStoreInventory default! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:11'!
checkout
	self answer.! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:25'!
displayItems: aCollection
	| list |
	aCollection size = 1 ifTrue: [^ self displayItem: aCollection first].
	list _ WABatchSelection
			 items: aCollection
			 link: #title
			 text: #subtitle.
	[self displayItem: (main call: list)] repeat
	! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:14'!
renderNavBarOn: html
	html form: [
		html bold: 'Search:'.
		html space.
		html textInputWithValue: '' callback: [:v | self search: v].
	].
	html anchorWithAction: [self browse] text: 'Browse'.
	cart hasItems ifTrue: 
		[html break.
		html anchorWithAction: [self checkout] text: 'Checkout']! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
browse
	self displayItems: self inventory allItems! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
search: aString
	| results |
	results _ self inventory findItem: aString.
	results isEmpty
		ifTrue: [main inform: 'No items match ', aString printString]
		ifFalse: [self displayItems: results].! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 15:33'!
style
^ '
	#search {vertical-align: bottom}
	#main {width: 50%; padding: 10px}
	#side {vertical-align: top; }
	#cart {border-style: dashed; border-width: 1; padding: 5px}
	#nav {background-color: lightgrey; vertical-align: top; padding: 5px; border-width: 1; width: 15%; font-size: 12pt}
	#batch {font-size: 10pt}
'! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:00'!
renderContentOn: html
	html table: [
"		html tableRowWith: trail span: 3."
		html tableRow: [
			html cssId: 'nav'; tableData: [self renderNavBarOn: html].
			html cssId: 'main'; tableData: main.
			html cssId: 'side'; tableData: cartView.
		]
	]! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 2/17/2003 00:00'!
renderAllOn: aRenderer
	self renderHeadElementsOn: aRenderer.
	self renderHeaderOn: aRenderer.
	self renderContentOn: aRenderer.
	self renderFooterOn: aRenderer.! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:31'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			currentPage = index
				ifFalse: [html anchorWithAction: [self currentPage: index] text: index]
				ifTrue: [html bold: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'initialization' stamp: 'avi 12/9/2003 13:17'!
initialize
	batchSize _ 10.
	currentPage _ 1.
	self session registerObjectForBacktracking: self.! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize _ aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
nextPage
	self isOnLastPage ifFalse: [currentPage _ currentPage + 1]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnFirstPage
	^ currentPage = 1! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:17'!
endIndex
	^ currentPage * batchSize min: items size! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items _ aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:05'!
batch
	^ items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnLastPage
	^ currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/29/2003 16:39'!
maxPages
	^ (items size / batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
previousPage
	self isOnFirstPage ifFalse: [currentPage _ currentPage - 1]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage _ aNumber! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:26'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html divNamed: 'batch' with: [
			self renderPreviousOn: html.
			self renderPagesOn: html. 
			self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:09'!
startIndex
	^ (currentPage - 1) * batchSize + 1! !

WAComponent subclass: #WAClosureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 15:59'!
go
	|i|
	i _ 1.
	#(a b c) do: [:each | self inform: each asString, ' ', i asString. i _ i + 1]! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 19:43'!
ensure
	[self go] ensure: [self inform: 'ensure']! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 19:47'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'.
	html space.
	html anchorWithAction: [self ensure] text: 'go with ensure'.! !

WAComponent subclass: #WAStorePaymentEditor
	instanceVariableNames: 'name cardType cardNumber month year '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStorePaymentEditor commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for editing WAStoreCreditCard instances.  When called, it presents a form for the user to choose credit card type, and enter name, number, and expiry date.  On submit, it will create and answer an instance of the appropiate credit card subclass.  Note the difference with WAStoreAddressEditor, where the form modifies the address instance directly.  Used by WAStoreTask>>getPaymentInfo.!

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:59'!
months
	^ (1 to: 12)! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:08'!
renderContentOn: html
	html form: [
		html table: [
			html tableRowWithLabel: 'Card Type' column: 
				[html
					selectFromList: self cardTypes
					selected: cardType
					callback: [:v | cardType _ v]
					labels: [:ea | ea abbreviation]].
			html tableRowWithLabel: 'Name' column:
				[html textInputWithValue: name callback: [:v | name _ v]].
			html tableRowWithLabel: 'Card Number' column:
				[html textInputWithValue: cardNumber callback: [:v | cardNumber _ v]].
			html tableRowWithLabel: 'Expiration Date' column:
				[html selectFromList: self months selected: month callback: [:m | month _ m].
				html selectFromList: self years selected: year callback: [:y | year _ y]].
			html spacerRow.
			html attributes alignCenter.
			html tableRowWith: [html submitButtonWithAction: [self ok] text: 'OK'] span: 2.
		]
	]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:06'!
cardTypes
	^ WAStoreCreditCard subclasses! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:09'!
ok
	self answer:
		(cardType new
			name: name;
			number: cardNumber;
			expiry: (Date newDay: 1 month: month year: year))! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:45'!
years
	^ (Date today year to: Date today year + 5)! !

WAComponent subclass: #WADialog
	instanceVariableNames: 'actions message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WADialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:08'!
renderContentOn: html
	html heading: message level: 3.
	html form: [
		actions do:
			[:assoc |
			html submitButtonWithAction: [self answer: assoc value value] text: assoc key]]! !

WADialog subclass: #WARadioDialog
	instanceVariableNames: 'label selection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 6/23/2003 15:23'!
label: aString
	label _ aString! !

!WARadioDialog class methodsFor: 'as yet unclassified' stamp: 'JF 6/23/2003 16:23'!
selectFrom: aCollection message: messageString label: labelString
	^ self new initializeWithActions: aCollection message: messageString label: labelString! !

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 6/23/2003 15:22'!
label
	^ label ifNil: [label _ 'OK']! !

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 9/15/2003 16:16'!
select: anObject
	selection contents: anObject! !

!WARadioDialog methodsFor: 'rendering' stamp: 'jf 1/12/2004 14:22'!
renderContentOn: html
	| group |
	html heading: message level: 3.
	
	group _ html radioGroup.
	
	html form: [
		actions do:
			[:assoc |
			html
				radioButtonInGroup: group
				selected: (selection contents = assoc value)
				callback:
					[:v |
					selection contents: assoc value.
					self answer: assoc value].
			html encodeText: assoc key.
			html break].
		
		html submitButtonWithText: label]! !

!WARadioDialog methodsFor: 'accessing' stamp: 'JF 9/15/2003 16:15'!
selection: aStateHolder
	selection _ aStateHolder! !

!WARadioDialog methodsFor: 'initializing' stamp: 'JF 9/15/2003 16:13'!
initializeWithActions: aCollection message: messageString label: labelString
	message _ messageString.
	label _ labelString.
	selection _ WAStateHolder new.
	
	aCollection do:
		[:each | self on: each key answer: each value]! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 17:57'!
confirmation: aString
	^ self new
			message: aString;
			on: 'Yes' answer: [true];
			on: 'No' answer: [false]! !

!WADialog methodsFor: 'as yet unclassified' stamp: 'ab 7/16/2002 11:29'!
message: aString
	message _ aString! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 19:42'!
message: aString
	^ self new
		message: aString;
		on: 'OK' answer: [true]! !

!WADialog methodsFor: 'as yet unclassified' stamp: 'ab 7/16/2002 11:29'!
initialize
	message _ 'Hello'.
	actions _ OrderedCollection new.! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:32'!
exampleMessage
	^ self message: 'Hello World'! !

!WADialog class methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:32'!
exampleConfirmation
	^ self confirmation: 'Tea?'! !

!WADialog methodsFor: 'as yet unclassified' stamp: 'ab 7/21/2002 15:55'!
on: aString answer: aBlock
	actions add: aString -> aBlock ! !

WAComponent subclass: #WAMessageFrame
	instanceVariableNames: 'message contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Dialogs'!

!WAMessageFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:01'!
contents: aController
	contents _ aController.
	contents onAnswer: [:v | self answer: v].! !

!WAMessageFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 17:59'!
message: aString
	message _ aString! !

!WAMessageFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:23'!
renderContentOn: html
	html cssClass: 'dialog-message'; heading: message level: 3.
	html divClass: 'dialog-contents' with: contents.! !

WAComponent subclass: #WAPrettyPrinter
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAPrettyPrinter methodsFor: 'as yet unclassified' stamp: 'ab 6/3/2003 00:17'!
root: aComponent
	root _ aComponent! !

!WAPrettyPrinter class methodsFor: 'as yet unclassified' stamp: 'ab 6/3/2003 00:20'!
on: aComponent
	^ self new root: aComponent! !

!WAPrettyPrinter methodsFor: 'as yet unclassified' stamp: 'jf 1/12/2004 16:14'!
style
	^'
.html-source {
	font-family: courier, serif;
	font-size: 9pt;
}

.xmlDeclaration {
	color: limegreen;
	font-style: italic;
}

.doctype {
	color: skyblue;
	font-style: italic;
}

.tag-known {
	color: purple;
	font-weight: bold;
}

.attribute-known {
	font-weight: bold;
}

.attribute-value {
	color: blue;
}

.template {
	color: blue;
	font-weight: bold;
}

'! !

!WAPrettyPrinter methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:38'!
renderContentOn: html
	| doc context |
	doc _ WAHtmlResponse new.
	context _ WARenderingContext new
					actionUrl: 'action';
					callbacks: WACallbackStore new;
					document: doc.
	root renderWithContext: context.

	html divClass: 'html-source' with: [doc renderOn: html]! !

WAComponent subclass: #WADateRangeSelector
	instanceVariableNames: 'startDate endDate '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Widgets'!

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
addDays: aNumber
	self dateRangeIsValid ifTrue:
		[startDate date: (startDate date addDays: aNumber).
		endDate date: (endDate date addDays: aNumber).
		self changeDates]
			! !

!WADateRangeSelector class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
nextDates
	self addDays: self dateRangeSize! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
endDate
	^ endDate date! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
previousDates
	self addDays: self dateRangeSize * -1! !

!WADateRangeSelector methodsFor: 'rendering' stamp: 'ab 5/25/2003 16:29'!
renderContentOn: html
	html form: [
		html table: [
			html tableRowWith: [html text: 'From:'] with: [html render: startDate].
			html tableRowWith: [html text: 'To:'] with: [html render: endDate].
			html tableRowWith: [] with:
				[html submitButtonWithAction: [self previousDates] text: 'Previous'.
				html submitButtonWithAction: [self nextDates] text: 'Next'.
				html space.
				html submitButtonWithAction: [self changeDates] text: 'Go'.
					]
		].
		self dateRangeIsValid ifFalse: [html paragraph: 'Invalid Date Range'].
	]! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 6/15/2003 12:45'!
changeDates
	self dateRangeIsValid ifTrue: [self changed]! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
dateRangeSize
	^ self dateRangeIsValid
		ifTrue: [self endDate subtractDate: self startDate]
		ifFalse: [0]! !

!WADateRangeSelector methodsFor: 'initialization' stamp: 'ab 5/25/2003 16:29'!
initialize

	startDate _ WADateSelector new date: Date today.
	endDate _ WADateSelector new date: (Date today addDays: 10)! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:26'!
startDate
	^ startDate date! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:29'!
startDate: aDate
	startDate date: aDate! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 5/25/2003 16:30'!
endDate: aDate
	endDate date: aDate! !

!WADateRangeSelector class methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:26'!
initialize
	self registerAsApplication: 'rates'! !

!WADateRangeSelector methodsFor: 'dates' stamp: 'ab 7/10/2003 11:32'!
dateRangeIsValid
	^ (startDate dateIsValid
		and: [endDate dateIsValid])
		and: [startDate date <= endDate date]! !

WAComponent subclass: #WATestTabs
	instanceVariableNames: 'tabs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WATestTabs methodsFor: 'as yet unclassified' stamp: 'avi 9/16/2003 12:57'!
initialize
	tabs _ WATabPanel withAll:
				(OrderedCollection new
					add: ('Input' -> WAInputTest new);
					add: ('Once' -> WAOnceTest new);
					add: ('Html' -> WAHtmlTest new);
					add: ('Encoding' -> WAEncodingTest new);
					add: ('Calendar' -> WACalendarTest new);
					add: ('Error' -> WAErrorTest new);
					add: ('Exception' -> WAExceptionTest new);
					add: ('Closure' -> WAClosureTest new);
					add: ('Transaction' -> WATransactionTest new);
					add: ('Upload' -> WAUploadTest new);
					add: ('Parent' -> (WAParentTest new parent: self));
					yourself)! !

!WATestTabs methodsFor: 'as yet unclassified' stamp: 'ab 3/5/2003 21:37'!
renderContentOn: html
	html heading: 'Test Components'.
	html render: tabs! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAScreenshot class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:47'!
initialize
	self registerAsApplication: 'screenshot'! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 02:01'!
toggleUIText
	^ Project uiProcess isSuspended
		ifFalse: ['Suspend UI Process']
		ifTrue: ['Resume UI Process']! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 02:01'!
toggleUIProcess
	Project uiProcess isSuspended
		ifTrue: [Project uiProcess resume]
		ifFalse: [Project uiProcess suspend]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'ab 10/2/2002 00:44'!
click: aPoint
	|evt|
	evt _ Sensor createMouseEvent.
	evt at: 3 put: aPoint x.
	evt at: 4 put: aPoint y.
	evt at: 5 put: 4.
	Sensor processEvent: evt.	
	evt at: 5 put: 0.
	Sensor processEvent: evt.	! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 02:02'!
renderContentOn: html
	html imageMapWithAction: [:pt | self click: pt] form: Display copy.
	html horizontalRule.
	html anchorWithAction: [self toggleUIProcess] text: self toggleUIText.
	! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/14/2003 02:30'!
delegate: aController
	delegate ifNil: [delegate _ WAStateHolder new].
	delegate contents: aController! !

!WAController methodsFor: 'call/answer' stamp: 'ab 6/24/2003 16:10'!
willAnswer
	^ true! !

!WAController methodsFor: 'convenience' stamp: 'ab 7/11/2003 18:10'!
request: requestString label: labelString default: initialString
	^ self call:
		((WAInputDialog new
			label: labelString;
			default: initialString)
				withMessage: requestString)! !

!WAController methodsFor: 'initialization' stamp: 'ab 6/24/2003 16:11'!
initializeController
	self willCall ifTrue: [delegate _ WAStateHolder new].
	self initialize.! !

!WAController methodsFor: 'convenience' stamp: 'JF 6/4/2003 12:14'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 18:11'!
withMessage: aString
	^ self new withMessage: aString! !

!WAController methodsFor: 'convenience' stamp: 'JF 6/4/2003 12:23'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:16'!
applicationWithPath: aString
	| app |
	self halt.
	app _ WAApplication path: aString.
	app configuration addAncestor: WAControllerConfiguration userConfiguration.
	app preferenceAt: #entryPoint put: self.
	^ app! !

!WAController methodsFor: 'call/answer' stamp: 'ab 2/14/2003 02:48'!
call: aComponent
	^ self delegateTo: aComponent during: [aComponent call]! !

!WAController methodsFor: 'call/answer' stamp: 'ab 2/13/2003 01:10'!
answer
	self answer: self! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/15/2003 15:50'!
clearDelegate
	self delegate: nil! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/14/2003 02:31'!
delegateTo: aController during: aBlock
	|value saved|
	saved _ self delegate.
	self delegate: aController.
	value _ aBlock value.
	self delegate: saved.
	^ value! !

!WAController methodsFor: 'rendering' stamp: 'ab 2/16/2003 23:57'!
renderOn: aRenderer
	"for compatibility"
	self renderActiveControllerWithContext: aRenderer context! !

!WAController methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAController methodsFor: 'rendering' stamp: 'ab 2/13/2003 01:30'!
renderWithContext: aContext! !

!WAController methodsFor: 'convenience' stamp: 'ab 7/11/2003 18:11'!
confirm: aString
	^ self call: (WAYesOrNoDialog withMessage: aString)! !

!WAController methodsFor: 'call/answer' stamp: 'avi 2/2/2004 01:43'!
call
	^ self willAnswer
		ifFalse: [WARenderNotification signal]
		ifTrue:
			[Continuation currentDo: 
				[:cc |
				continuation _ cc.
				WARenderNotification signal]]! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 18:24'!
registerAsApplication: appName sessionClass: sessionClass
	^ (self registerAsApplication: appName)
		preferenceAt: #sessionClass put: sessionClass;
		yourself! !

WAController subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tasks'!

WATask subclass: #WAPluggableTask
	instanceVariableNames: 'block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tasks'!

!WAPluggableTask methodsFor: 'initialization' stamp: 'jf 11/10/2003 16:31'!
initializeWithBlock: aBlock
	super initializeController.
	block _ aBlock! !

!WAPluggableTask methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:38'!
block: aBlock
	block _ aBlock! !

!WAPluggableTask methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2003 16:38'!
go
	^ block value: self! !

!WAPluggableTask class methodsFor: 'instance creation' stamp: 'jf 11/10/2003 16:18'!
withBlock: aBlock
	^ self basicNew initializeWithBlock: aBlock! !

WATask subclass: #WATool
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

WATool subclass: #WAExplorerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAExplorerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Explore'! !

!WAExplorerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:53'!
title
	^ 'Component Explorer'! !

!WAExplorerTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:44'!
go
	self call: (WAExplorer on: root)! !

!WATool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:42'!
root: aController
	root _ aController! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
linkText
	^ self name! !

WATool subclass: #WAMemoryUseTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
title
	^ 'Memory Use'! !

!WAMemoryUseTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:44'!
go
	self call: (WAMemoryUse new root: self session)! !

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Memory Use'! !

WATool subclass: #WAProfilerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WAProfilerTool methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
go
	self call: (WAProfiler new child: root)! !

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
linkText
	^ 'Profile'! !

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
title
	^ 'Profiler'! !

WATool subclass: #WABrowserTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools-Squeak'!

!WABrowserTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:45'!
go
	self call: (WABrowser fullOnClass: root activeController class)! !

!WABrowserTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
title
	^ 'System Browser'! !

!WABrowserTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Browse'! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
title
	^ self name! !

WATask subclass: #WAOnceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAOnceTest methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 17:33'!
go
	self inform: 'ready'.
	self session once: [1 to: 3 do: [:i | self inform: i asString]].
	self inform: 'done'.! !

!WATask methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 19:31'!
renderWithContext: aContext
	"this will cause a #call: to happen from within the render phase - don't try this at home"
	[self answer: self go] repeat! !

WATask subclass: #WATransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WATransactionTest methodsFor: 'as yet unclassified' stamp: 'ab 2/13/2003 16:51'!
go
	self inform: 'Before parent txn'.
	self session isolate: 
			[self inform: 'Inside parent txn'.
			self session isolate: [self inform: 'Inside child txn'].
			self inform: 'Outside child txn'].
	self inform: 'Outside parent txn'! !

WATask subclass: #WAStoreTask
	instanceVariableNames: 'cart '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store'!

!WAStoreTask commentStamp: 'avi 1/1/2004 10:19' prior: 0!
This task models the main application flow of the store example.  Most of the other components in the example are called from here.  The flow is defined by the #go method.  After creating a WAStoreCart instance, this calls WAStoreFillCart to allow the user to add items to it.  It then calls WAStoreCartConfirmation, WAStoreAddressEditor, and WAStorePaymentEditor in succession for the checkout process.  Many of the components it calls are wrapped with informative messages (#withMessage:) and validation (#validateWith:).  It also makes use of WASession>>isolate: to ensure that once the checkout process starts, backtracking to modify the cart is forbidden.  Used by WAStore.!

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:28'!
displayConfirmation
	self inform: 'Your fish is on its way.'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:51'!
fillCart
	self call: (WAStoreFillCart new cart: cart)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:37'!
getPaymentInfo
	^ self call:
		((WAStorePaymentEditor new
			validateWith: [:p | p validate])
				withMessage: 'Please enter your payment information:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:04'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"no-op"! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:02'!
getAddressWithMessage: aString
	^ self call:
		((WAStoreAddressEditor new
			validateWith: [:a | a validate])
				withMessage: aString)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:03'!
confirmContentsOfCart
	^ self call:
		((WAStoreCartConfirmation new cart: cart)
			withMessage: 'Please verify your order:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:26'!
go
	| shipping billing creditCard |
	cart _ WAStoreCart new.
	self session isolate:
		[[self fillCart.
		self confirmContentsOfCart]
			whileFalse].

	self session isolate:
		[shipping _ self getShippingAddress.
		billing _ (self useAsBillingAddress: shipping)
					ifFalse: [self getBillingAddress]
					ifTrue: [shipping].
		creditCard _ self getPaymentInfo.
		self shipTo: shipping billTo: billing payWith: creditCard].

	self displayConfirmation.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:44'!
useAsBillingAddress: anAddress
	^ self confirm: 'Do you wish to use ', anAddress street printString, ' as your billing address?'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:43'!
getBillingAddress
	^ self getAddressWithMessage: 'Please enter your billing address:'.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:43'!
getShippingAddress
	^ self getAddressWithMessage: 'Please enter your shipping address:'.! !

!WATask methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

WATask subclass: #WAExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Test'!

!WAExceptionTest methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:14'!
go
	[(self confirm: 'Raise an exception?')
		ifTrue: [self error: 'foo']]
			on: Error
			do: [:e | self inform: 'Caught: ', e asString]! !

!WAController methodsFor: 'delegation' stamp: 'ab 2/15/2003 15:51'!
activeController
	^ self delegate
		ifNil: [self]
		ifNotNil: [self delegate activeController]! !

!WAController class methodsFor: 'as yet unclassified' stamp: 'ab 3/28/2003 16:19'!
new
	^ super new initializeController! !

!WAController methodsFor: 'delegation' stamp: 'ab 6/24/2003 16:11'!
delegate
	^ self willCall ifTrue: [delegate contents] ! !

!WAController methodsFor: 'call/answer' stamp: 'ab 2/13/2003 01:10'!
answer: anObject
	continuation ifNotNil: [continuation value: anObject]! !

!WAController methodsFor: 'call/answer' stamp: 'ab 5/25/2003 17:29'!
onAnswer: aBlock
	continuation _ aBlock! !

!WAController methodsFor: 'convenience' stamp: 'ab 7/11/2003 18:08'!
withMessage: aString
	^ WAMessageFrame new
		contents: self;
		message: aString;
		yourself! !

!WAController methodsFor: 'convenience' stamp: 'ab 2/18/2003 20:30'!
request: aString
	^ self request: aString default: ''! !

Object subclass: #WAStateHolder
	instanceVariableNames: 'contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-State'!

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:05'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	contents printOn: aStream.
	aStream nextPut: $).! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents
	^ contents! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents: anObject
	contents _ anObject! !

!WAStateHolder class methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:48'!
new
	|inst|
	inst _ super new.
	WASession currentSession registerObjectForBacktracking: inst.
	^ inst! !

Object subclass: #WAResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

WAResponse subclass: #WANotFoundResponse
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WANotFoundResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:13'!
location: aString
	^ self new location: aString! !

!WANotFoundResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:14'!
status
	^ '404'! !

!WANotFoundResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:13'!
location: aString
	location _ aString! !

!WANotFoundResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:31'!
contentString
	^ '<h1> Error: "', location, '" not found. </h1>'.! !

WAResponse subclass: #WARedirectResponse
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WARedirectResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:45'!
location: aString
	location _ aString
! !

!WARedirectResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:40'!
status
	^ '302'! !

!WARedirectResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:45'!
headers
	^ Array with: 'Location' -> location! !

!WARedirectResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:40'!
location: aString
	^ self new location: aString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 16:40'!
status
	^ '200'! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 14:55'!
new
	^ super new initialize! !

WAResponse subclass: #WAGenericResponse
	instanceVariableNames: 'contentType headers cookies status stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:45'!
status: statusString
	status _ statusString! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
cookieAt: key put: value
	cookies at: key put: value! !

!WAGenericResponse class methodsFor: 'as yet unclassified' stamp: 'ab 12/30/2002 17:32'!
new
	^ super new initialize! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
headerAt: key put: value
	headers at: key put: value! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:58'!
contentType: mimeTypeString
	contentType _ mimeTypeString! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
cookies
	^ cookies! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
headers
	^ headers! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAGenericResponse class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 22:49'!
document: anObject mimeType: mimeType
	|doc|
	doc _ anObject asMIMEDocument.
	^ self new
		contentType: (mimeType ifNil: [doc contentType]);
		headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
		nextPutAll: doc content! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 5/28/2003 22:54'!
initialize
	headers _ Dictionary new.
	cookies _ Dictionary new.
	stream _ String new writeStream.
	status _ '200'.
	contentType _ 'text/html'.
! !

!WAGenericResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:38'!
contents
	^ stream contents readStream! !

!WAResponse methodsFor: 'http' stamp: 'ab 5/28/2003 22:47'!
initialize
	! !

WAResponse subclass: #WABasicAuthResponse
	instanceVariableNames: 'realm '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:34'!
status
	^ '401'! !

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:44'!
realm: aString
	realm _ aString.
! !

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:45'!
headers
	^ Array with: 'WWW-Authenticate' -> ('Basic realm="',realm,'"')! !

!WABasicAuthResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:31'!
contentString
	^ '<h1>Authentication Failed</h1>'! !

!WABasicAuthResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 16:34'!
realm: aString
	^ self new realm: aString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
headers
	^ #()! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:49'!
contentString
	^ self printString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:33'!
contents
	^ self contentString readStream! !

!WAResponse methodsFor: 'optimizing' stamp: 'JF 6/17/2003 17:30'!
release
	1 to: self class instSize do: [:i | self instVarAt: i put: nil]! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 16:40'!
contentType
	^ 'text/html'! !

WAResponse subclass: #WAHtmlResponse
	instanceVariableNames: 'head stack body '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlResponse methodsFor: 'markup' stamp: 'avi 11/20/2003 18:36'!
closeTag: aString
	self popElement name = aString ifFalse: [self error: 'Mismatched tags']! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'avi 11/20/2003 18:36'!
popElement
	^ stack removeLast! !

!WAHtmlResponse methodsFor: 'accessing' stamp: 'ab 1/11/2003 12:29'!
body
	^ body! !

!WAHtmlResponse methodsFor: 'accessing' stamp: 'ab 1/11/2003 12:29'!
head
	^ head! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:57'!
pushElement: anObject
	self addElement: anObject.
	stack add: anObject.! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:58'!
withElement: anElement do: aBlock
	self pushElement: anElement.
	aBlock value.
	self popElement.! !

!WAHtmlResponse methodsFor: 'rendering' stamp: 'jf 1/12/2004 16:07'!
renderOn: html
	| root |
	html spanClass: 'xmlDeclaration' with: [html encodeText: self xmlDeclaration]; break.
	html spanClass: 'doctype' with: [html encodeText: self docType].
	root _ WAHtmlElement named: 'html'.
	
	root add: head.
	root add: body.
	
	root renderOn: html indentLevel: 0! !

!WAHtmlResponse methodsFor: 'markup' stamp: 'avi 11/20/2003 18:50'!
openTag: aString attributes: anAttributes
	self pushElement: (WAHtmlElement named: aString attributes: anAttributes)! !

!WAHtmlResponse methodsFor: 'markup' stamp: 'avi 11/20/2003 18:37'!
headTag: aString attributes: anAttributes
	self head add: (WAHtmlElement named: aString attributes: anAttributes)! !

!WAHtmlResponse methodsFor: 'markup' stamp: 'avi 11/20/2003 18:38'!
headTag: aString attributes: anAttributes content: contentString
	self head add:
		((WAHtmlElement named: aString attributes: anAttributes)
			add: contentString;
			yourself)! !

!WAHtmlResponse class methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 12:27'!
new
	^ super new initialize! !

!WAHtmlResponse methodsFor: 'as yet unclassified' stamp: 'jf 1/12/2004 16:04'!
printHtmlOn: aStream
	aStream nextPutAll: self xmlDeclaration; cr.
	aStream nextPutAll: self docType; cr.
	aStream nextPutAll: '<html>'.
	head printHtmlOn: aStream.
	body printHtmlOn: aStream.
	aStream nextPutAll: '</html>'.! !

!WAHtmlResponse methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:46'!
addElement: anObject
	stack last add: anObject! !

!WAHtmlResponse methodsFor: 'markup' stamp: 'avi 11/20/2003 18:50'!
text: aString
	self addElement: aString! !

!WAHtmlResponse methodsFor: 'accessing' stamp: 'ab 6/15/2003 16:44'!
initialize
	head _ WAHtmlElement named: 'head'.
	body _ WAHtmlElement named: 'body'.
	stack _ OrderedCollection with: body! !

!WAHtmlResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 22:03'!
contents
	|stream|
	stream _ ReadWriteStream on: String new.
	self printHtmlOn: stream.
	^ stream reset! !

!WAHtmlResponse methodsFor: 'as yet unclassified' stamp: 'jf 1/12/2004 16:04'!
docType
	^ '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">'! !

!WAHtmlResponse methodsFor: 'as yet unclassified' stamp: 'jf 1/12/2004 16:04'!
xmlDeclaration
	^ '<?xml version="1.0" encoding="UTF-8"?>'! !

WAResponse subclass: #WARefreshResponse
	instanceVariableNames: 'location delay message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Responses'!

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:17'!
message: aString
	message _ aString! !

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:33'!
contentString
	^ '<html>
			<head>
			<meta http-equiv="refresh" content="',delay asString,';URL=',location,'">
			<title>',message,'</title>
			</head>
			<body>
			<h1>',message,'</h1>
			You are being redirected to <a href="',location,'">',location,'</a>
			</body>
		</html>'
	! !

!WARefreshResponse class methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:16'!
message: aString location: urlString delay: aNumber
	^ self new
		message: aString;
		location: urlString;
		delay: aNumber! !

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:17'!
delay: aNumber
	delay _ aNumber! !

!WARefreshResponse methodsFor: 'as yet unclassified' stamp: 'ab 2/5/2003 17:17'!
location: aString
	location _ aString! !

!WAResponse methodsFor: 'http' stamp: 'ab 2/5/2003 17:42'!
cookies
	^ #()! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|members|
	members _ self class allInstVarNames
					collect: [:ivar | ivar -> (self instVarNamed: ivar)].
						
	self class isVariable ifTrue:
		[members _ members, ((1 to: self size) collect: [:i | i -> (self at: i)])].
	^ members! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'associations '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlAttributes methodsFor: 'private' stamp: 'jf 1/12/2004 16:37'!
associations
	^ associations ifNil: [associations _ OrderedCollection new]! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:42'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast put: aMessage argument].
	^ super doesNotUnderstand: aMessage! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 15:04'!
cssClassForAttribute: aString
	^ (self isKnownAttribute: aString) ifTrue: ['attribute-known'] ifFalse: ['attribute-unknown']! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:58'!
isKnownAttribute: aString
	^ self knownAttributes includes: aString asLowercase! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'ab 5/12/2003 22:08'!
alignCenter
	self at: 'align' put: 'center'! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'ab 5/12/2003 11:21'!
printHtmlOn: aStream
	associations ifNotNil:
		[associations do:
			[:assoc |
			self printAttribute: assoc on: aStream]].! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 15:06'!
renderAttribute: assoc on: html
	| attr value |
	attr _ assoc key asLowercase.
	value _ assoc value.
	
	value = false ifFalse:
		[html space.
		html spanClass: (self cssClassForAttribute: attr) with:
			[html encodeText: attr].
		html encodeText: '='.
		html spanClass: 'attribute-value' with:
			[html encodeText: '"'.
			value = true
				ifFalse: [html encodeText: value asString]
				ifTrue: [html encodeText: attr].
			html encodeText: '"']]! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:57'!
knownAttributes
	^ #(abbr
accept-charset
accept
accesskey
action
align
alink
alt
archive
axis
background
bgcolor
bgproperties
border
cellpadding
cellspacing
char
charoff
charset
checked
cite
class
classid
clear
code
codebase
codetype
color
cols
colspan
compact
content
coords
data
datetime
declare
defer
dir
direction
disabled
encoding
enctype
face
for
frame
frameborder
framespacing
gutter
headers
height
href
hreflang
hspace
http-equiv
id
ismap
label
lang
leftmargin
link
longdesc
loop
lowsrc
marginheight
marginwidth
maxlength
media
method
methods
multiple
name
nohref
noresize
noshade
nowrap
object
onabort
onblur
onchange
onclick
ondblclick
onerror
onfocus
onkeydown
onkeypress
onkeyup
onload
onmousedown
onmousemove
onmouseout
onmouseover
onmouseup
onreset
onselect
onsubmit
onunload
prompt
PUBLIC
readonly
rel
rev
rows
rowspan
rules
scheme
scope
scrolling
selected
shape
size
span
src
standby
style
summary
tabindex
target
text
title
type
urn
usemap
valign
value
valuetype
version
vlink
vspace
width
wrap
xml:lang
xmlns)! !

!WAHtmlAttributes methodsFor: 'rendering' stamp: 'JF 6/11/2003 13:06'!
renderOn: html
	associations ifNotNil:
		[associations do:
			[:assoc |
			self renderAttribute: assoc on: html]].! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'jf 1/12/2004 16:38'!
at: keyString put: valueString
	self associations add: keyString -> valueString.! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'ab 5/12/2003 11:21'!
printAttribute: assoc on: aStream
	assoc value = false ifFalse:
		[aStream nextPut: $ .
		aStream nextPutAll: assoc key asLowercase.
		aStream nextPutAll: '="'.
		assoc value = true
			ifFalse: [aStream nextPutAll: assoc value asString]
			ifTrue: [aStream nextPutAll: assoc key asLowercase].
		aStream nextPut: $"]! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'jf 1/12/2004 16:40'!
at: keyString ifAbsentPut: valueString
	^ self associations
		detect: [:ea | ea key = keyString]
		ifNone: [self associations add: keyString -> valueString. valueString]! !

Object subclass: #WACallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
evaluateWithObject: anObject store: aCallbackStore
	self subclassResponsibility ! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isValueCallback
	^ false! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:04'!
evaluateWithObject: anObject store: aCallbackStore
	self value: anObject! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 23:20'!
block: aBlock
	block _ aBlock fixTemps! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:04'!
value: anObject
	block numArgs = 1
		ifTrue: [block value: anObject]
		ifFalse: [block value]! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isValueCallback
	^ true! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:02'!
isDispatchCallback
	^ false! !

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:46'!
trigger
	block value! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isActionCallback
	^ true! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:01'!
evaluateWithObject: anObject store: aCallbackStore
	aCallbackStore action: self! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 23:19'!
block: aBlock
	block _ aBlock fixTemps! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:02'!
isActionCallback
	^ false! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Callbacks'!

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 20:03'!
isDispatchCallback
	^ true! !

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:49'!
evaluateWithObject: anObject store: aCallbackStore
	aCallbackStore evaluateCallbackAt: anObject with: nil! !

Object subclass: #Amb
	instanceVariableNames: 'failureContinuation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Backtracking'!

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:12'!
deny: aBoolean
	self assert: aBoolean not! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:15'!
fail
	^ failureContinuation value: nil! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo or: blockThree
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo with: blockThree)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:29'!
maybe
	^ self oneOf: (Array with: true with: false)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
allValues: aBlock
	|kPrev results|
	kPrev _ failureContinuation.
	results _ OrderedCollection new.
	(Continuation currentDo:
		[:kRetry |
		failureContinuation _ [:v | kRetry value: false].
		results add: aBlock value.
		kRetry value: true])
			ifTrue: [self fail].
	failureContinuation _ kPrev.
	^ results asArray	 ! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:09'!
oneOf: aCollection
	^ self valueOfOneOf: (aCollection collect: [:ea | [ea] fixTemps])! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
valueOfOneOf: blockCollection
	|kPrev|
	kPrev _ failureContinuation.
	^ Continuation currentDo:
		[:kEntry |
		blockCollection do:
			[:ea |
			Continuation currentDo:
				[:kNext |
				failureContinuation _
					[:v | failureContinuation _ kPrev. kNext value: v] fixTemps.
				kEntry value: ea value]].
		kPrev value: nil]
			 ! !

!Amb class methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 01:59'!
new
	^ super new initialize! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:00'!
initialize
	failureContinuation _ [self error: 'Amb tree exhausted'].! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:11'!
assert: aBoolean
	aBoolean ifFalse: [self fail]! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields path headers cookies handlerKey actionKey method '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'private' stamp: 'ab 8/26/2003 19:34'!
setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	method _ methodString.
	url _ urlString.
	headers _ headDict.
	fields _ fieldDict.
	cookies _ cookieDict.
	self parseUrl.! !

!WARequest methodsFor: 'accessing' stamp: 'ab 11/12/2002 00:04'!
cookies
	^ cookies! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/31/2004 17:59'!
clearActionKey
	actionKey _ ''! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:17'!
hasHandlerKey
	^ handlerKey isEmpty not! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:42'!
path
	^ path! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
user
	^ self authorization ifNotNilDo: [:auth | auth copyUpTo: $:]! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
password
	^ self authorization ifNotNilDo: [:auth | auth copyAfter: $:]! !

!WARequest methodsFor: 'private' stamp: 'ab 1/13/2003 22:40'!
authorization
	^ (self headerAt: 'Authorization' ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:auth | self decodeAuthorization: auth]! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'private' stamp: 'ab 7/11/2003 00:09'!
parseUrl
	|stream|
	
	stream _ url readStream.
	path _ stream upToAndSkipThroughAll: WARegistry handlerKeySeparator.
	handlerKey _ stream upTo: $/.
	actionKey _ stream upToEnd.
! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:20'!
handlerKey
	^ handlerKey! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'ab 2/11/2003 20:20'!
actionKey
	^ actionKey! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:34'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	^ self new setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Reporting'!

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 21:50'!
new
	^ super new initialize! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
initialize
	formatBlock _ [:x | x asString].
	sortBlock _ [:a :b | a <= b].
	valueBlock _ [:row | nil].
	clickBlock _ nil.
	title _ 'Untitled'.
	hasTotal _ false.! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock _ aBlock! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock _ [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
hasTotal: aBoolean
	hasTotal _ aBoolean ! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs _ anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs _ assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title _ aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:08'!
canSort
	^ sortBlock notNil! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock _ aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock _ [:row | row perform: aSymbol]! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

Object subclass: #WAStoreAddress
	instanceVariableNames: 'name street city country '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store-Model'!

!WAStoreAddress commentStamp: 'avi 1/1/2004 07:36' prior: 0!
A simple model of a billing or shipping address.  Stores strings for a person's name, street, city, and country.  Apart from accessors for these, the only behavior this provides is a #validate method which will throw errors if street, city, or country is nil.!

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
city
	^ city! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
country
	^ country! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
name: aString
	name _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
city: aString
	city _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:05'!
validate
	street ifNil: [self error: 'You must provide a street address.'].
	city ifNil: [self error: 'You must provide a city.'].
	country ifNil: [self error: 'You must provide a country.'].! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
street: aString
	street _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
name
	^ name! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
street
	^ street! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
country: aString
	country _ aString! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: 'Registry '
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:53'!
allAttributes
	^ Array streamContents:
		[:s | 
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]
! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/1/2004 14:52'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock seen: (Set with: self)! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'ancestors values '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:34'!
initialize
	super initialize.
	values _ Dictionary new.
	ancestors _ OrderedCollection new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:34'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:21'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:15'!
clear
	values _ Dictionary new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:17'!
localValueForAttribute: anAttribute ifAbsent: errorBlock
	^ values at: anAttribute key ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:35'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:17'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:18'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:18'!
takeValue: anObject forAttribute: anAttribute
	^ values at: anAttribute key put: anObject! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 2/1/2004 15:25'!
name
	^ self class registry keyAtValue: self ifAbsent: ['Anonymous']! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/1/2004 18:37'!
globalUserConfiguration
	^ WAConfiguration named: 'Global User Configuration'! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:16'!
named: aString
	^ self registry at: aString ifAbsentPut: [self new]! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 2/1/2004 16:32'!
valueForAttribute: anAttribute
	^ self localValueForAttribute: anAttribute ifAbsent: [self lookupValueForAttribute: anAttribute]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:54'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [:ea | ea key = aSymbol]
		ifNone: [self error: 'No attribute named ', aSymbol printString]
! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 2/1/2004 18:06'!
allAncestors
	^ Array streamContents:
		[:stream | self allAncestorsDo: [:ea | stream nextPut: ea]]! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:38'!
registry
	^ Registry ifNil: [Registry _ Dictionary new]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration methodsFor: 'testing' stamp: 'jf 2/1/2004 18:03'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]
	
	! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/2/2004 14:20'!
localValueForAttribute: anAttribute ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/2/2004 14:16'!
hasLocalValueForAttribute: anAttribute
	self localValueForAttribute: anAttribute ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/2/2004 14:20'!
lookupValueForAttribute: anAttribute
	self allAncestorsDo:
		[:ea |
		(ea localValueForAttribute: anAttribute ifAbsent: [])
			ifNotNilDo: [:val | ^ val]].
	^ nil! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/1/2004 14:51'!
allAncestorsDo: aBlock
	^ self allAncestorsDo: aBlock seen: Set new! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/1/2004 14:49'!
ancestorsDo: aBlock seen: aSet
! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance '!

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:01'!
attributes
	self subclassResponsibility ! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configurations'!

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:56'!
attributes
	^ Array 
		with: ((WAListAttribute key: #serverProtocol) options: #(http https))
		with: (WAStringAttribute key: #serverHostname)
		with: (WANumberAttribute key: #serverPort)! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 16:52'!
attributes
	^ Array
		with: (WABooleanAttribute key: #showToolbar)
		with: (WABooleanAttribute key: #alwaysRedirect)
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass) options: self sessionClasses)
		with: ((WAListAttribute key: #applicationFlow) options: self applicationFlowClasses)
		with: ((WAListAttribute key: #errorHandler) options: self errorHandlerClasses)! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:06'!
ancestors
	^ Array with: WAGlobalConfiguration userConfiguration! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:04'!
applicationFlowClasses
	^ WAApplicationFlow allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
alwaysRedirect
	^ true! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 17:03'!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:04'!
sessionClasses
	^ WASession withAllSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
showToolbar
	^ true! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:32'!
localValueForAttribute: anAttribute ifAbsent: absentBlock
	^ (self respondsTo: anAttribute key)
		ifTrue: [self perform: anAttribute key]
		ifFalse: [absentBlock value]! !

WASystemConfiguration subclass: #WAControllerConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

!WAControllerConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:07'!
attributes
	^ Array with: ((WAListAttribute key: #entryPoint) options: self entryPoints)! !

!WAControllerConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:07'!
entryPoints
	^ WAController allSubclasses asSortedCollection: [:a :b | a name <= b name]! !

!WAControllerConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:08'!
applicationFlow
	^ WARenderLoop! !

!WAControllerConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:09'!
ancestors
	^ Array with: (WASessionConfiguration userConfiguration)! !

!WAControllerConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 17:02'!
errorHandler
	^ WAWalkbackErrorHandler! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:59'!
newUserConfiguration
	^ WAUserConfiguration new
		addAncestor: self instance;
		yourself! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:14'!
userConfigurationName
	^ self name! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
userConfiguration
	^ Registry at: self userConfigurationName ifAbsentPut: [self newUserConfiguration]! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:58'!
instance
	^ instance ifNil: [instance _ self new]! !

!WAConfiguration methodsFor: 'initializing' stamp: 'avi 2/2/2004 14:34'!
initialize
	! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:25'!
valueAt: aSymbol
	^ self valueForAttribute: (self attributeNamed: aSymbol)! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:34'!
allAncestorsDo: aBlock seen: aSet
	self ancestors do:
		[:ea |
		(aSet includes: ea) ifFalse:
			[aSet add: ea.
			aBlock value: ea.
			ea allAncestorsDo: aBlock seen: aSet]]! !

Object subclass: #WAFile
	instanceVariableNames: 'contents fileName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Utilities'!

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName
	"compensate for windows explorer behavior"
	^ ('#:\*' match: fileName)
		ifTrue: [fileName copyAfterLast: $\]
		ifFalse: [fileName]! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents
	^ contents! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents: aStream
	contents _ aStream! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName: aString
	fileName _ aString! !

Object subclass: #WAKom
	instanceVariableNames: 'entryPoint '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Connections'!

WAKom class
	instanceVariableNames: 'port service '!

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryComponent: aClass path: aString
	^ self dispatcher: (aClass applicationWithPath: aString)! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:54'!
createService
	Smalltalk at: #HttpService ifPresent:
		[:hs |
		^ (hs on: port named: 'seaside') plug: self default].
	Smalltalk at: #ComancheNetService ifPresent:
		[:cns |
		^ (cns named: 'seaside' onPort: port) module: self default]! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
startOn: aPort
	self stop.
	port _ aPort.
	service _ self createService.
	service start.
! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 14:11'!
validateForStack: anArray! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2003 00:48'!
convertResponse: aResponse
	| komResponse |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].

	komResponse _  HttpResponse new.

	aResponse cookies associationsDo:
		[:assoc | komResponse setCookieName: assoc key value: assoc value path: '/'].
		
	aResponse headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	(HttpResponse classPool at: #StatusCodes) associationsDo:
		[:assoc |
		assoc value key = aResponse status ifTrue: [komResponse status: assoc key]].
	komResponse contents: aResponse contents.
	komResponse contentType: aResponse contentType.

	^ komResponse
! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:33'!
setDeploymentMode
	service setDeploymentMode.! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setDebugMode
	service setDebugMode.! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
stop
	self pause.
	port _ nil.
! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
pause
	service ifNotNil:
		[service unregister.
		service _ nil]! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 13:53'!
processHttp
	HttpResponse current: (self process: HttpRequest current).
	^ true! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
initialize
		Smalltalk addToStartUpList: self after: AutoStart.
		Smalltalk addToShutDownList: self! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 1/20/2004 13:25'!
process: komRequest
	|request response komResponse|
	self log: komRequest.
	request _ self convertRequest: komRequest.

	response _ self handleRequest: request.
	komResponse _ self convertResponse: response.

	response release.

	^ komResponse! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 11:24'!
processHttpRequest: aRequest
	^ self process: aRequest! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
shutdown
	self pause! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:56'!
handleRequest: aRequest
	^ (entryPoint handlerForRequest: aRequest) handleRequest: aRequest! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	entryPoint _ anEntryPoint! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
processMultipartFields: aRequest
	aRequest multipartFormFieldsDo:
		[:chunk |
		chunk fileName isEmptyOrNil ifFalse:
			[|stream file|
			stream _ WriteStream on: String new.
			chunk saveToStream: stream.
			file _ WAFile new fileName: chunk fileName; contents: stream contents.
			aRequest postFields at: chunk fieldName put: file]].! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 00:48'!
convertRequest: aKomRequest
	| request |
	self processMultipartFields: aKomRequest.

	request _ WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (aKomRequest method = 'POST'
					ifTrue: [aKomRequest postFields]
					ifFalse: [aKomRequest getFields])
		cookies: aKomRequest cookies.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setVerboseMode
	service setVerboseMode.! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:44'!
default
	^ self entryPoint: WADispatcher default! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 00:43'!
log: aRequest
	Transcript cr; show: aRequest url! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	^ self new entryPoint: anEntryPoint! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
startUp
	port ifNotNil: [self startOn: port]! !

Object subclass: #WAStoreCart
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store-Model'!

!WAStoreCart commentStamp: 'avi 1/1/2004 07:44' prior: 0!
A shopping cart.  This is essentially a specialized Bag: you can #add: or #remove: WAStoreItems to it, and calculate their #totalPrice.  You can also use #countsAndItems to get a collection of associations between the items and the number of times they appear in the cart, useful for summary displays.!

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
remove: anObject
	items remove: anObject ifAbsent: []! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:01'!
hasItems
	^ items notNil and: [items isEmpty not]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:21'!
items
	^ items! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:41'!
totalPrice
	^ items detectSum: [:ea | ea price]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
countsAndItems
	^ items sortedCounts! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:36'!
add: anObject
	items ifNil: [items _ Bag new].
	items add: anObject! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:50'!
renderOpenTagOn: html 
	html encodeText: '<'.
	html spanClass: self cssClass with: [html encodeText: self name].
	
	attributes renderOn: html.
	
	self shouldPrintCloseTag 
		ifFalse: [html space; encodeText: '/'].
	html encodeText: '>'.! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 12:58'!
renderOn: html indentLevel: level
	html break.
	level timesRepeat: [html space].
	
	self renderOpenTagOn: html.
	self childrenDo: [:ea | ea renderOn: html indentLevel: level + 1].
	self shouldPrintCloseTag ifTrue:
		[self shouldIndentCloseTag ifTrue:
			[html break.
			level timesRepeat: [html space]].
		self renderCloseTagOn: html].! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:53'!
renderCloseTagOn: html 
	html encodeText: '</'.
	html spanClass: self cssClass with: [html encodeText: self name].
	html encodeText: '>'.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:17'!
shouldIndentCloseTag
	^ children notNil and: [children anySatisfy: [:ea | ea isString not]]! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:49'!
cssClass
	^ self isKnownTag ifTrue: ['tag-known'] ifFalse: ['tag-unknown']! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:10'!
childrenDo: aBlock
	children ifNotNil: [children do: aBlock]! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:44'!
printOpenTagOn: aStream 
	aStream
		nextPut: $<;
		nextPutAll: self name.
	attributes printHtmlOn: aStream.
	self shouldPrintCloseTag ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:47'!
name
	^ name asLowercase! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'jf 1/12/2004 14:14'!
shouldPrintCloseTag
	^(#(#hr #br #input #img #link) includes: self name) not! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString attributes: anAttributes
	^ self new initializeWithName: aString attributes: anAttributes! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString
	^ self named: aString attributes: (WAHtmlAttributes new)! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:10'!
printHtmlOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea printHtmlOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:14'!
attributeAt: aString put: anObject
	attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 13:47'!
add: anElement
	children ifNil: [children _ OrderedCollection new].
	children add: anElement.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:16'!
initializeWithName: aString attributes: anAttributes
	name _ aString.
	attributes _ anAttributes! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:38'!
knownTags
	^ #(?xml
!!doctype
!!dt
a
abbr
acronym
address
applet
area
attach
b
base
basefont
bdo
big
blink
blockquote
body
br
button
caption
center
cite
code
col
colgroup
comment
component
dd
del
dfn
dir
div
dl
dt
em
fieldset
font
form
frame
frameset
h
h1
h2
h3
h4
h5
h6
head
hr
html
i
iframe
img
input
ins
isindex
kbd
label
legend
li
link
listing
map
menu
meta
multicol
nextid
nobr
noframes
noscript
object
ol
optgroup
option
p
param
plaintext
pre
q
s
samp
script
select
small
span
strike
strong
style
sub
sup
table
tbody
td
textarea
textflow
tfoot
th
thead
title
tr
tt
u
ul
var
wbr
xmp)! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:44'!
printCloseTagOn: aStream 
	aStream
		nextPutAll: '</';
		nextPutAll: self name;
		nextPut: $>! !

!WAHtmlElement methodsFor: 'rendering' stamp: 'JF 6/11/2003 14:58'!
isKnownTag
	^ self knownTags includes: self name! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:37'!
at: key put: val
	|removals|
	table at: key put: val.
	ageTable at: val put: 0.
	removals _ OrderedCollection new.
	ageTable associationsDo:
		[:assoc |
		assoc value > max ifTrue: [removals add: assoc key].
		assoc value: assoc value + 1].
	removals do: [:ea | self remove: ea].
	! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max _ aNumber! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:55'!
nextKey
	|key|
	[table includesKey: (key _ WAExternalID new asString)] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:23'!
store: anObject
	|key|
	key _ self nextKey.
	self at: key put: anObject.
	^ key! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
at: key
	^ self at: key ifAbsent: [self error: 'No entry for ', key]! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:48'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:28'!
at: key ifAbsent: errorBlock
	|val|
	val _ table at: key ifAbsent: [^ errorBlock value].
	ageTable at: val put: 0.
	^ val.! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
new
	^ super new initialize! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 19:07'!
initialize
	max _ 20.
	table _ Dictionary new.
	ageTable _ Dictionary new.! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl callbacks document '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Core'!

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document _ anObject! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
callbacks
	"Answer the value of callbacks"

	^ callbacks! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl: anObject
	"Set the value of actionUrl"

	actionUrl _ anObject! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
callbacks: anObject
	"Set the value of callbacks"

	callbacks _ anObject! !

Object subclass: #WARequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Handlers'!

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:43'!
isActive
	^ true! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:22'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document _ anObject.
	mimeType _ mimeString.
	mimeDocument _ document asMIMEDocument.
	fileName _ fileString.! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:33'!
response
	| response |
	response _ WAGenericResponse new.
	response nextPutAll: mimeDocument content contents.
	response contentType: (mimeType ifNil: [mimeDocument contentType]).
	response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName ifNotNil: 
		[response headerAt: 'Content-Disposition' put: 'attachment; filename=' , fileName].
	^ response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:41'!
= other
	^ (other species = self species
		and: [other document = self document])
		and: [other mimeType = self mimeType]! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler class methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:33'!
handleRequest: aRequest
	self subclassResponsibility! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'basePath '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:48'!
configurationComponent
	^ nil! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath: aString
	basePath _ aString! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath
	^ basePath! !

!WAEntryPoint methodsFor: 'printing' stamp: 'JF 9/22/2003 20:06'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self basePath, ')'! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

WADispatcher class
	instanceVariableNames: 'default '!

!WADispatcher methodsFor: 'public' stamp: 'ab 7/10/2003 11:48'!
removeEntryPoint: anObject
	entryPoints removeKey: (entryPoints keyAtValue: anObject)! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'JF 9/15/2003 14:40'!
default
	default ifNil: [default _ self new].
	default basePath ifNil: [default basePath: '/seaside'].
	
	^ default! !

!WADispatcher methodsFor: 'public' stamp: 'ab 5/26/2003 00:10'!
handleRequest: aRequest
	^ (self handlerForRequest: aRequest) handleRequest: aRequest! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Subdirectory'! !

!WADispatcher methodsFor: 'private' stamp: 'ab 8/26/2003 21:55'!
handlerForRequest: aRequest
	| path name |
	path _ aRequest url.
	(path beginsWith: basePath)
		ifTrue: [name _ ((path allButFirst: basePath size) findTokens: '/') at: 1 ifAbsent: [].
				entryPoints at: name ifPresent: [:n | ^ n]].
	^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:53'!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:09'!
new
	^ super new initialize! !

!WADispatcher methodsFor: 'private' stamp: 'ab 8/26/2003 21:08'!
initialize
	entryPoints _ Dictionary new! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:11'!
registerEntryPoint: entryPoint at: aString
	entryPoints at: aString put: entryPoint.
	entryPoint basePath: basePath, '/', aString.! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:51'!
concreteSubclasses
	^ self allSubclasses reject: [:ea | ea isAbstract]! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Core'!

!WARegistry methodsFor: 'private' stamp: 'ab 5/28/2003 23:52'!
registerRequestHandler: anObject
	|key|
	key _ WAExternalID new: 16.
	self shouldCollectHandlers ifTrue: [self collectExpiredHandlers].
	handlersByKey at: key put: anObject.
	keysByHandler at: anObject put: key.
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
shouldCollectHandlers
	^ 10 atRandom = 1! !

!WARegistry methodsFor: 'private' stamp: 'ab 6/9/2003 22:56'!
collectExpiredHandlers
	(handlersByKey reject: [:ea | ea isActive]) do: [:ea | self unregisterRequestHandler: ea]! !

!WARegistry methodsFor: 'private' stamp: 'ab 6/9/2003 22:55'!
unregisterRequestHandler: anObject
	handlersByKey removeKey: (keysByHandler at: anObject).
	keysByHandler removeKey: anObject! !

!WARegistry methodsFor: 'private' stamp: 'ab 6/9/2003 22:56'!
handleKeyRequest: aRequest
	|key handler|
	key _ [WAExternalID fromString: aRequest handlerKey] on: Error do: [nil].
	handler _ handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry methodsFor: 'public' stamp: 'ab 5/29/2003 00:02'!
handleRequest: aRequest
	^ aRequest hasHandlerKey
		ifTrue: [self handleKeyRequest: aRequest]
		ifFalse: [self handleDefaultRequest: aRequest]
! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
initialize
	self clearHandlers.! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:30'!
handleExpiredRequest: aRequest
	^ self handleDefaultRequest: aRequest! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
expiredHandlerForRequest: aRequest
	^ self createHandlerForRequest: aRequest! !

!WARegistry methodsFor: 'public' stamp: 'ab 5/18/2003 12:26'!
urlForRequestHandler: anObject path: pathString
	|key|
	key _ keysByHandler at: anObject ifAbsent: [self registerRequestHandler: anObject].
	^ pathString, self class handlerKeySeparator, key asString! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'JF 9/22/2003 20:15'!
clearAllHandlers
	self allSubInstances do: [:ea | ea clearHandlers]! !

!WARegistry methodsFor: 'public' stamp: 'ab 5/26/2003 01:34'!
urlForRequestHandler: anObject
	^ self urlForRequestHandler: anObject path: self basePath! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:26'!
handlerKeySeparator
	^ '/@'! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
clearHandlers
	handlersByKey _ Dictionary new.
	keysByHandler _ Dictionary new.! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
new
	^ super new initialize! !

WARegistry subclass: #WAApplication
	instanceVariableNames: 'configuration sessionClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 2/2/2004 15:17'!
defaultAncestor
	"yes, breaking layering"
	^ WAControllerConfiguration userConfiguration! !

!WAApplication methodsFor: 'request handling' stamp: 'avi 1/31/2004 18:19'!
handleDefaultRequest: aRequest
	|session|
	aRequest clearActionKey.
	session _ self sessionClass application: self.
	^ session handleRequest: aRequest! !

!WAApplication methodsFor: 'accessing' stamp: 'jf 2/1/2004 20:30'!
urlForRequestHandler: anObject path: pathString
	^ self serverUrl, (super urlForRequestHandler: anObject path: pathString)! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
path: pathString
	^ self new basePath: pathString! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:34'!
configurationComponent
	^ WAApplicationEditor new application: self! !

!WAApplication methodsFor: 'preferences' stamp: 'jf 2/1/2004 20:02'!
serverUrl
	| serverProtocol serverHostname serverPort |
	serverProtocol _ self preferenceAt: #serverProtocol.
	serverHostname _ self preferenceAt: #serverHostname.	
	serverPort _ self preferenceAt: #serverPort.	
	
	serverHostname ifNil: [^ ''].
	
	^ String streamContents:
		[:stream |
		stream nextPutAll: serverProtocol.
		stream nextPutAll: '://'.
		stream nextPutAll: serverHostname.
		
		((self defaultPortForProtocol: serverProtocol) = serverPort)
			ifFalse: [stream nextPutAll: ':', serverPort asString]]! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol put: anObject
	^ self configuration valueAt: aSymbol put: anObject! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 2/2/2004 15:17'!
configuration
	^ configuration ifNil: [configuration _ WAUserConfiguration new addAncestor: self defaultAncestor]! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 5/26/2003 01:22'!
name
	^ (basePath findTokens: '/') last! !

!WAApplication methodsFor: 'basic configuration' stamp: 'avi 1/31/2004 18:19'!
sessionClass
	^ configuration valueAt: #sessionClass! !

!WAApplication methodsFor: 'preferences' stamp: 'jf 2/1/2004 20:22'!
defaultPortForProtocol: protocolSymbol
	| ports |
	ports _ Dictionary withAll: {#http -> 80. #https -> 443}.
	
	^ ports at: protocolSymbol! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Seaside Application'! !

WARequestHandler subclass: #WATimeoutRequestHandler
	instanceVariableNames: 'lastAccess expired timeout '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Handlers'!

WATimeoutRequestHandler subclass: #WASession
	instanceVariableNames: 'continuations application escapeContinuation monitor path filters state '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

!WASession methodsFor: 'path' stamp: 'avi 1/23/2004 01:00'!
pathTokens
	^ (path contents allButFirst: self basePath size) findTokens: '/'! !

!WASession methodsFor: 'state' stamp: 'ab 2/18/2003 18:51'!
registerObjectForBacktracking: anObject
	state registerObject: anObject! !

!WASession methodsFor: 'responding' stamp: 'avi 2/2/2004 01:54'!
pageIntentionallyLeftBlank
	self returnResponse: WAGenericResponse new! !

!WASession methodsFor: 'filters' stamp: 'ab 2/19/2003 01:48'!
once: aBlock
	self filter: WAOnce new do: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 01:54'!
withEscapeContinuation: aBlock
	^ Continuation currentDo:
			[:cc |
			escapeContinuation := cc.
			aBlock value.
			self pageIntentionallyLeftBlank]! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/31/2004 17:45'!
unknownRequest: aRequest
	self pageExpired! !

!WASession methodsFor: 'filters' stamp: 'avi 2/2/2004 13:04'!
basicAuthentication: authBlock do: aBlock
	^ self authenticateWith: (WABlockAuthenticator new block: authBlock) during: aBlock! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/23/2004 14:21'!
incomingRequest: aRequest
	^ monitor critical: [self responseForRequest: aRequest]! !

!WASession methodsFor: 'printing' stamp: 'ab 5/26/2003 01:38'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', (application urlForRequestHandler: self), ')'! !

!WASession methodsFor: 'filters' stamp: 'ab 2/15/2003 20:24'!
removeFilter: aFilter
	filters contents: (filters contents copyWithout: aFilter)! !

!WASession methodsFor: 'expiring' stamp: 'avi 2/2/2004 01:53'!
pageExpired
	state restoreLastSnapshot.
	self redirectWithMessage: 'That page has expired.' delay: 3.
	WAPageExpired signal! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 16:51'!
responseForRequest: aRequest
	path contents: aRequest path.
	^ self withEscapeContinuation: [self withErrorHandler: [self performRequest: aRequest]]! !

!WASession methodsFor: 'responding' stamp: 'avi 1/23/2004 15:38'!
redirect
	self respond: [:url | WARedirectResponse location: url]! !

!WASession methodsFor: 'responding' stamp: 'ab 2/5/2003 17:34'!
redirectWithMessage: aString delay: aNumber
	self respond:
		[:url |
		WARefreshResponse
			message: aString
			location: url
			delay: aNumber].
! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 16:52'!
errorHandler
	^ application preferenceAt: #errorHandler! !

!WASession class methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 15:12'!
currentSession
	|context|
	context _ thisContext.
	[context isNil] whileFalse:
		[(context receiver isKindOf: self) ifTrue: [^ context receiver].
		context _ context sender].
	^ nil
! !

!WASession methodsFor: 'initializing' stamp: 'ab 5/26/2003 01:53'!
initialize! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 16:57'!
handleWarning: aWarning
	self errorHandler new handleWarning: aWarning.
	WAPageExpired signal! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 16:54'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: (MessageSend receiver: self selector: #handleError:)]
		on: Warning
		do: (MessageSend receiver: self selector: #handleWarning:)! !

!WASession class methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 01:53'!
application: anApplication
	^ self new initializeWithApplication: anApplication! !

!WASession methodsFor: 'accessing' stamp: 'ab 3/20/2003 11:43'!
application
	^ application! !

!WASession methodsFor: 'filters' stamp: 'JF 5/16/2003 17:52'!
filter: aFilter do: aBlock
	self addFilter: aFilter.
	aBlock value.
	self removeFilter: aFilter! !

!WASession methodsFor: 'filters' stamp: 'avi 1/23/2004 15:34'!
isolate: aBlock
	|txn|
	txn _ WATransaction new.
	self filter: txn do: aBlock.
	txn close.! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 16:57'!
handleError: anError
	self errorHandler new handleError: anError.
	WAPageExpired signal! !

!WASession methodsFor: 'responding' stamp: 'ab 5/26/2003 01:40'!
actionUrlForKey: aString
	^ (application urlForRequestHandler: self path: self path), '/', aString! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 01:36'!
start: aRequest
	(self applicationFlowClass session: self) start: aRequest! !

!WASession methodsFor: 'path' stamp: 'ab 5/26/2003 01:53'!
path
	^ path contents! !

WASession subclass: #WAControllerSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

!WAControllerSession methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
note
	"Purely for backwards compatibility"! !

!WASession methodsFor: 'filters' stamp: 'ab 2/15/2003 20:24'!
addFilter: aFilter
	filters contents: (filters contents copyWith: aFilter)! !

!WASession methodsFor: 'responding' stamp: 'ac 5/30/2003 13:40'!
redirectTo: urlString
	self returnResponse: (WARedirectResponse location: urlString)! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/23/2004 14:09'!
performRequest: aRequest
	(continuations at: aRequest actionKey ifAbsent: [[:r | self unknownRequest: r]])
		value: aRequest! !

!WASession methodsFor: 'accessing' stamp: 'avi 2/2/2004 01:42'!
applicationFlowClass
	^ application preferenceAt: #applicationFlow! !

!WASession methodsFor: 'path' stamp: 'avi 1/23/2004 01:20'!
pathTokens: anArray
	self addToPath:
		(String streamContents:
			[:s |
			anArray
				do: [:ea | s nextPutAll: ea asString]
				separatedBy: [s nextPut: $/]])! !

!WASession methodsFor: 'filters' stamp: 'avi 2/2/2004 13:05'!
authenticateWith: anAuthenticator during: aBlock
	self filter: (WABasicAuthentication new authenticator: anAuthenticator) do: aBlock
! !

!WASession methodsFor: 'responding' stamp: 'avi 1/23/2004 15:38'!
respond: responseBlock
	|request snapshot|
	snapshot _ state snapshot.
	request _ 
	Continuation currentDo:
		[:cc ||url|
		url _ self actionUrlForContinuation: cc.
		self returnResponse: (responseBlock value: url)].
	state restoreSnapshot: snapshot.
	filters contents do: [:ea | ea handleRequest: request inSession: self].
	^ request ! !

!WASession methodsFor: 'initializing' stamp: 'avi 1/23/2004 19:05'!
initializeWithApplication: anApplication
	application _ anApplication.
	continuations _ WALRUCache new.
	monitor _ WAProcessMonitor new.
	state _ WAStateRegistry new.
	filters _ WAStateHolder new contents: #().
	path _ WAStateHolder new contents: self basePath.
	continuations at: '' put: (MessageSend receiver: self selector: #start:).
	self initialize.! !

!WASession methodsFor: 'path' stamp: 'ab 5/26/2003 01:34'!
basePath
	^ application basePath! !

!WASession methodsFor: 'path' stamp: 'ab 5/26/2003 01:53'!
addToPath: aString
	path contents: self basePath, '/', aString! !

!WASession methodsFor: 'responding' stamp: 'avi 1/23/2004 15:38'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: aContinuation)! !

!WASession methodsFor: 'responding' stamp: 'ab 6/15/2003 19:25'!
returnResponse: aResponse
	escapeContinuation value: aResponse! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
expired
	^ expired ifNil: [false]! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
isActive
	^ self expired not and: [self secondsSinceLastAccess < self timeoutSeconds]! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:19'!
lastAccess
	^ lastAccess ifNil: [lastAccess _ Time totalSeconds]! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:08'!
incomingRequest: aRequest
	self subclassResponsibility ! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
defaultTimeoutSeconds
	^ 600! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:19'!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:08'!
handleRequest: aRequest
	lastAccess _ Time totalSeconds.
	^ self incomingRequest: aRequest! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds: aNumber
	timeout _ aNumber! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
expire
	expired _ true! !

!WATimeoutRequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds
	^ timeout ifNil: [self defaultTimeoutSeconds]! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Handlers'!

!WANotFoundHandler methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 00:07'!
handleRequest: aRequest
	^ WANotFoundResponse location: aRequest path! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Utilities'!

!WAModelProxy methodsFor: 'accessing' stamp: 'ab 11/26/2002 17:22'!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
value
	^ model value! !

!WAModelProxy class methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 17:21'!
on: anObject
	^ self new setModel: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:53'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse:
			[(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]! !

!WAModelProxy methodsFor: 'initializing' stamp: 'ab 12/12/2002 00:18'!
setModel: anObject
	model _ anObject.
	cache _ Dictionary new.! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 12/12/2002 00:18'!
commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache _ Dictionary new.
! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:50'!
performRead: aSymbol
	^ cache at: aSymbol ifAbsent: [model perform: aSymbol]! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:51'!
performWrite: aSymbol with: anObject
	cache at: aSymbol put: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
name
	^ model name! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 18:39'!
performRealWrite: aSymbol with: anObject
	model perform: (aSymbol,':') asSymbol with: anObject! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/26/2002 20:05'!
renderOn: aRenderer
	aRenderer text: self! !

Object subclass: #WAStoreInventory
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store-Model'!

WAStoreInventory class
	instanceVariableNames: 'default '!

!WAStoreInventory commentStamp: 'avi 1/1/2004 09:33' prior: 0!
The list of inventory items.  In a real application, this would probably have to deal with persistence, maintaining inventory counts, etc.  In this example, it just builds a collection of WAStoreItems from a hardcoded data set, and provides #allItems and #findItem: for accessing these.!

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
allItems
	^ items! !

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:17'!
new
	^ self basicNew initialize! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
findItem: searchString
	^ items select: [:ea | ea matches: searchString]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
itemSpecs
"adapted from http://www.thaddeus.com/ftp/database/sushi.zip"
	^ #(
#('Akami Maguro' 'Red Tuna' 'The lean meat near the spine of the tuna fish.  It comes in various shades of red--with the lighter, shinier varieties being the best.  For dieters, however, the redder the better.  Easy on the palatte.  The least expensive of the three types of maguro.' 150)
#('Chutoro Maguro' 'Fatty Tuna' 'The moderately fatty part of the tuna belly.  It''s pink, but not the faint pink of ohtoro.  Soft, butter-like texture.  Moderately expensive.' 275)
#('Geso Ika' 'Cuttlefish Tentacles' 'White in color, geso is boiled and brushed with thick teriyaki sauce before serving as sushi.  Its texture is chewy, and its mild flavor is complemented by the sweet-salty teriyaki.' 200)
#('Himo Akagai' 'Ark Shell Filaments' 'This is the thread-like edges which connect the flesh to the shell.  A delicious, soft texture and mild taste.' 200)
#('Hotategai' 'Scallop' 'The part of the scallop that is eaten is the edible adductor muscle that opens the animal''s shell.  It''s pale beige-yellow in color with a brown, crusty edging.  The taste is delicate, and melts in your mouth. ' 250)
#('Iwashi' 'Sardine' 'Shiny, slippery, and ''fishy,'' the taste of sardine sushi is slightly oily.  Sardine must be eaten shortly after it has been caught if it''s to be used in Sushi.  Often eaten with soy sauce mixed with ginger and onion.' 175)
#('Kazunoko' 'Herring Roe' 'An expensive delicacy which is also known as ''yellow diamonds'' (because of the color and expense).  Revered in Japan, it''s usually eaten on special occasions.  An acquired taste for Westerners.' 475)
#('Kisu' 'Sillago' 'A fresh Sillago has bright-gold skin. The taste is mild and delicate.' 225)
#('Ohtoro Maguro' 'Fattiest Tuna' 'Fattiest part of the fatty tuna belly.  It is light pink in color and melts in your mouth.  Mild with a rich texture.  This is the most expensive of the three types of Maguro sushi.' 325)
#('Shima-Aji' 'Yellow Jack' 'A slice of white silvery shima-aji eaten with beef-steak plant and fresh ginger is delicious.  The flavor is delicate and the texture of good, fresh yellow jack is smooth and slides down easily.' 180)
#('Aji' 'Horse Mackerel' 'This fish is pink-grey and shiny.  When it''s fresh, the flesh is almost transparent.  The texture is slippery and easy on the tongue--it should melt in your mouth.  Aji is often eaten with soy sauce containing onion, ginger and garlic.' 250)
#('Inarizushi' 'Stuffed Bean Curd Rolls' '' 200)
#('Kappa Maki' 'Cucumber Rolls' '' 150)
#('Sakura Denbu' 'Shredded Cod Fish' 'Seasoned shredded cod fish.' 200)
#('California Roll' '' 'Rice, cucumber, crab meat, & avacado.' 250)
#('Futo-Maki' 'Fat Rolls' 'Kampyo gourd, oboro or denbu pink powder, tamago omelet, and shiitake mushrooms. May also include bamboo shoots, cucumbers, cooked eel, cooked carrots, and cooked spinach or other greens.' 275)
#('Tekkamaki' 'Tuna Roll' 'Tuna wrapped in rice and nori.' 225)
#('Chakinzushi' 'Omelet-wrapped Sushi' 'Sushi rice in a thin omelet wrapper shaped and tied like a lady''s drawstring purse.  Sometimes a single pea or small shrimp decorates the ruffled part of the wrapper.' 300)
#('Shiro Maguro' 'Albacore Tuna' '' 300)
#('Hamachi' 'Yellowtail' '' 325)
#('Kohada' 'Gizzard Shad' 'This Japanese shad is a member of the herring family, and is a small silver-grey fish, with a black spotted back.  Marinated in vinegar and cross- hatched before serving.  The taste is strong, and a favorite for herring fans.' 275)
#('Katsuo' 'Bonito' '' 275)
#('Saba' 'Mackerel' '' 200)
#('Sake' 'Salmon' '' 250)
#('Tai' 'Red Snapper' '' 250)
#('Hirame' 'Flounder' 'Good hirame is a sushi gourmet''s delight.  Since it''s cut from such a small part of the fish, it''s scarce and expensive.  In appearance, it''s pale pink and smooth, with no markings.  The taste is delicate and buttery.' 350)
#('Suzuki' 'Sea Bass' '' 300)
#('Unagi' 'Freshwater Eel' '' 300)
#('Ika' 'Cuttlefish' 'When fresh, cuttlefish is almost transparent.  It''s butter-like and melts in your mouth.  The texture is sticky.  Cuttlefish is smoky white and glistens. Also popular grilled and mixed with ginger soy sauce.  Also good with lemon for Western palettes.' 325)
#('Awabi' 'Abalone' 'Abalone or ''sea snail'' is another sushi favorite.  The color ranges from beige-grey to pinkish yellow.  Fresh abalone is not too rubbery, and is very subtle in flavor.' 300)
#('Mirugai' 'Horse Clam' 'Also known as Geoduck.  This is a large, hard-shelled clam which is yellowish-white in color.  It has a slight ''shellfish'' taste and an elastic type texture. The part used in sushi is the long muscular siphon which projects from the shell.' 350)
#('Akagai' 'Ark Shell Clam' 'The softest texture of any shellfish. Akagai has an attractive pink-orange color.  The taste is delicate and slightly sweet.' 300)
#('Kobashira' 'Trough Shell (Small) Scallop' 'The edible adductor muscle that opens the shell of the aoyagi.  More prized than the aoyagi itself.' 500)
#('Kani' 'Crab' '' 250)
#('Ebi' 'Cooked Prawn' '' 225)
#('Ikura' 'Salmon Roe' 'Appealing to the eye with its bright red color.  Very appetizing with a delicate taste.' 325)
#('Tobiko ' 'Flying-Fish Roe' '' 350)
#('Masago ' 'Capelin Roe' '' 350)
#('Anago' 'Conger Eel' 'Anago is one of the few pre-cooked sushi.  It is grilled and basted with a thick teriyaki sauce.  The soft, slighty warm eel, the sweet soy sauce, and the vinegared rice make a particularly delicious sushi.' 300)
#('Uni' 'Sea Urchin Roe' 'A prized delicacy with its oily, rich texture.  Mustard color, paste-like topping is held in place by a band of nori seaweed.' 400)
) asSortedCollection: [:a :b | a first <= b first]! !

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:26'!
default
	^ default ifNil: [default _ self new]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
initialize
	items _ OrderedCollection new.
	self itemSpecs do:
		[:row |
		items add: (self itemFromSpec: row)]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
itemFromSpec: anArray
	^ WAStoreItem new
		title: anArray first;
		subtitle: anArray second;
		description: anArray third;
		price: anArray fourth! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Platform'!

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:18'!
profileSendsDuring: aBlock
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.	
	^ String streamContents: 
			[:stream | 
			(MessageTally new)
				spyEvery: 1
				on: [aBlock value. Smalltalk garbageCollectMost];
				report: stream]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:23'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPSocket
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:23'!
smtpServer
	^ 'localhost'! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 14:57'!
vmStatisticsReportString
	^ Utilities vmStatisticsReportString ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:04'!
mimeDocumentClass
	^ MIMEDocument ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
base64Decode: aString
	^ (Base64MimeConverter mimeDecodeToChars: aString readStream) contents
		! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:02'!
weakDictionaryOfSize: aNumber
	| dict |
	dict _ WeakIdentityKeyDictionary new: aNumber.
	WeakArray addWeakDependent: dict.
	^ dict! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

WAErrorHandler subclass: #WAWalkbackErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

!WAWalkbackErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 17:07'!
handleError: anError
	(WARenderLoop session: (WASession currentSession)) call: (WAWalkback new exception: anError).
	anError defaultAction! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 16:54'!
handleWarning: aWarning
	self handleError: aWarning! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 16:54'!
handleError: anError
	anError pass! !

Object subclass: #VWSqueakExtensionsInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Info'!

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:29'!
includesClass: aClass
	^ false! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:26'!
externalName
	^ 'Seaside-Squeak'! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:27'!
classes
	^ #()! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:30'!
methodSpecs
	^ #((String beginsWith:)
		(String findTokens:)
		(SequenceableCollection allButFirst:))! !

!VWSqueakExtensionsInfo class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:28'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self new on:
		(FileStream forceNewFileNamed: 'SeasideSqueakExtensions.st')! !

!VWSqueakExtensionsInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:27'!
methods
	^ self methodSpecs collect:
		[:pair |
		MethodReference new
			setClassSymbol: pair first
			classIsMeta: false
			methodSymbol: pair second
			stringVersion: '']! !

Object subclass: #WABlockAuthenticator
	instanceVariableNames: 'block '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

!WABlockAuthenticator methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 13:04'!
block: aBlock
	block _ aBlock! !

!WABlockAuthenticator methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 13:04'!
verifyPassword: passString forUser: userString
	^ block value: userString value: passString! !

Object subclass: #WAModLisp
	instanceVariableNames: 'listener '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Connections'!

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:01'!
readDataFrom: aSocket 
	| key info stream|
	info _ Dictionary new.
	stream _ SocketStream on: aSocket.
	[(key _ stream upTo: Character lf) = 'end']
		whileFalse: [
			stream next.
			info at: key asLowercase put: (stream upTo: Character lf).
			stream next].
	info at: 'content-length' ifPresent:
		[:cl | info at: 'content' put: (stream next: cl asNumber + 1)].
	^ info! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 5/7/2002 11:08'!
serve: aSocket
	[self process: aSocket. aSocket closeAndDestroy] fork! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 1/14/2003 01:49'!
process: aSocket
	| info query |	
	info _ self readDataFrom: aSocket.
	query _ self processQuery: info.
	self halt.! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 1/14/2003 01:46'!
serveOn: port
	Socket initializeNetwork.
	listener ifNotNil: [listener stop].
	listener _ ConnectionHandler onPort: port handler: [:s | self serve: s] priority: Processor highIOPriority.
	listener start.! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 14:58'!
processQuery: infoDictionary 
	^ (infoDictionary at: 'method') = 'GET'
		ifTrue: [self decodeFields: ((infoDictionary at: 'url') copyAfter: $?)]
		ifFalse: [self processPost: infoDictionary]
! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'ab 6/2/2002 18:06'!
unEscape: aString 
	"Convert escape sequences to their proper characters."
	| rs c |
	rs _ ReadStream on: aString.
	^ String streamContents:
		[:ws |
			[rs atEnd]
				whileFalse:
				[c _ rs next.
				ws
				nextPut: (c = $+
						ifTrue: [$ ]
						ifFalse: [c = $%
								ifTrue: [(Number readFrom: (rs next: 2) asUppercase base: 16) asCharacter]
								ifFalse: [c]])]]! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 10/21/2001 07:42'!
decodeFields: aString 
	"Convert the form fields in aString to a query dictionary."
	| query dict i key value |
	query _ aString findTokens: '&'.
	dict _ Dictionary new.
	query
		do: [:tag | 
			i _ tag indexOf: $=.
			key _ tag copyFrom: 1 to: i - 1.
			value _ i < tag size
						ifTrue: [self
								unEscape: (tag copyFrom: i + 1 to: tag size)].
			(dict includesKey: key)
				ifTrue: [((dict at: key)
							isKindOf: String)
						ifTrue: [dict
								at: key
								put: (OrderedCollection
										with: (dict at: key))].
					(dict at: key)
						add: value]
				ifFalse: [dict at: key put: value]].
	^ dict! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:16'!
processMultipartFields: aString withSeparator: aSeparator
	^ self processMultipartFields:
		(aString findBetweenSubStrs: (Array with: aSeparator))! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:08'!
processMultipartFields: aString
	self halt.
	^ Dictionary new! !

!WAModLisp class methodsFor: 'as yet unclassified' stamp: 'AB 12/8/2001 00:22'!
start
	self startOn: 3000! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'AB 3/23/2002 15:14'!
processPost: infoDictionary 
	^ (infoDictionary at: 'content-type') = 'application/x-www-form-urlencoded'
		ifTrue: [self decodeFields: (infoDictionary at: 'content')]
		ifFalse: [self processMultipartFields: (infoDictionary at: 'content')
					  withSeparator: ((infoDictionary at: 'content-type') copyAfter: $=)]
! !

!WAModLisp class methodsFor: 'as yet unclassified' stamp: 'AB 12/14/2001 17:29'!
startOn: port
	instances ifNil: [instances _ Dictionary new].
	(instances at: port ifAbsentPut: [self new]) serveOn: port.! !

Object subclass: #Continuation
	instanceVariableNames: 'values '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Backtracking'!

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context _ aContext.
	[context notNil] whileTrue: [context _ context swapSender: nil]
! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 23:29'!
initializeFromContext: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context size do: [:i | valueStream nextPut: (context at: i)].
		context _ context sender].
	values _ valueStream contents! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:17'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context size do: [:i | context at: i put: valueStream next]]! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	^ aVisitor visitStringAttribute: self with: anObject! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitNumberAttribute: self with: anObject! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
accept: aVisitor with: anObject
	^ aVisitor visitBooleanAttribute: self with: anObject! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Configuration'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options _ aCollection! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:17'!
initializeWithKey: aSymbol
	key _ aSymbol! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:17'!
key: aSymbol
	^ self basicNew initializeWithKey: aSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	self subclassResponsibility ! !

Object subclass: #WAHtmlBuilder
	instanceVariableNames: 'attributeBuffer '
	classVariableNames: 'HtmlCharacters '
	poolDictionaries: ''
	category: 'Seaside/Base-Document'!

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock with: anotherBlock
	self tableRow: [ self tableData: aBlock; tableData: anotherBlock]! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableHeading: aBlock
	self tag: 'th' do: aBlock! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'avi 11/20/2003 18:39'!
headTag: aString with: child
	self document headTag: aString attributes: self attributes content: child.
	attributeBuffer _ nil.! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divClass: aString with: anObject
	self cssClass: aString; div: anObject! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock span: aNumber
	self tableRow: [ self attributeAt: 'colspan' put: aNumber. self tableData: aBlock ]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
list: aCollection do: aBlock
	self tag: #ul do:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 19:01'!
encodeCharacter: aCharacter
	self text: ('&#', aCharacter asInteger asString, ';').  ! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString altText: altString
	self attributeAt: 'alt' put: altString.
	self attributeAt: 'src' put: urlString.
	
	self tag: #img.! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:27'!
attributeAt: aString put: anObject
	self attributes at: aString put: anObject.
	! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString
	self image: urlString altText: ''! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 1/11/2003 12:44'!
attributes: aCollection
	aCollection associationsDo: [:x | self attributeAt: x key put: x value]! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ac 5/16/2003 16:11'!
render: anObject
	anObject renderOn: self! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:19'!
anchorWithUrl: urlString title: titleString do: aBlock
	self attributes	title: titleString.
	self anchorWithUrl: urlString do: aBlock.! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 19:03'!
text: anObject
	self document text: anObject asString! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:26'!
inputWithType: type
	self inputWithType: type named: nil
! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
div: aBlock
	self tag: 'div' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'avi 11/20/2003 18:39'!
headTag: aString
	self document headTag: aString attributes: self attributes.
	attributeBuffer _ nil.! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:27'!
attributes
	^ attributeBuffer ifNil: [attributeBuffer _ WAHtmlAttributes new]! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:53'!
buttonForUrl: urlString withText: labelString data: assocCollection
	self formWithMethod: 'GET' action: urlString do:
		[assocCollection do: 
			[:each | self
				inputWithType: 'hidden'
				named: each key asString
				value: each value].
		self submitButtonWithText: labelString]
! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/11/2003 17:01'!
italic: aBlock
	self tag: 'i' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanClass: aString with: anObject
		self cssClass: aString; span: anObject! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
title: aString
	self headTag: 'title' with: aString! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
span: aBlock
	self tag: 'span' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:16'!
formWithAction: actionUrl do: aBlock
	self formWithMethod: 'post' action: actionUrl do: aBlock! !

!WAHtmlBuilder methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:41'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self tag: aMessage selector].
	argCount = 1 ifTrue: [^ self tag: aMessage selector allButLast do: aMessage argument].
	^ super doesNotUnderstand: aMessage
! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:45'!
document
	self subclassResponsibility ! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
break
	self tag: 'br'! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
heading: anObject level: aNumber
	self tag: 'h', aNumber asString do: anObject! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph: aBlock
	self tag: 'p' do: aBlock! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssId: aString
	self attributeAt: 'id' put: aString! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'ab 7/3/2003 14:56'!
buttonForUrl: urlString withText: labelString
	self buttonForUrl: urlString withText: labelString data: #()
! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock
	self tableRow: [ self tableData: aBlock ]! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssClass: aString
	self attributeAt: 'class' put: aString! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'jf 1/12/2004 16:41'!
inputWithType: type named: name value: value
	name ifNotNil:
		[self attributes
			at: 'name' put: name;
			at: 'id' ifAbsentPut: name].
	value ifNotNil: [self attributes value: value asString].
		
	self attributes type: type.
	
	self tag: 'input'.
! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString
	self openTag: aString.
	self closeTag: aString.! !

WAHtmlBuilder subclass: #WAHtmlRenderer
	instanceVariableNames: 'context anchorNames '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Core'!

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/14/2004 23:22'!
openSelect
	| name |
	name _ self callbacks registerDispatchCallback.
	self attributes
		at: 'name' put: name;
		at: 'id' ifAbsentPut: name.
	self openTag: 'select'.	! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:47'!
context
	^ context! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:54'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock
	self openSelect.
	callbackBlock fixTemps.

	aCollection do:
		[:item |
		self
			optionWithLabel: (labelsBlock value: item)
			selected: (item = selectedObject)
			callback: [callbackBlock value: item]].
	self closeTag: 'select'.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'IP 10/31/2003 12:26'!
openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName
	self attributeAt: 'href' put: (self urlForDocument: anObject mimeType: mimeType fileName: fileName).
	self openTag: #a.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'jf 11/21/2003 17:47'!
checkboxWithValue: aBoolean callback: callbackBlock
	| value |
	value _ ValueHolder new.
	self hiddenInputWithCallback: [value contents: false].

	self attributeAt: 'checked' put: aBoolean.
	self 
		valueInputOfType: 'checkbox'
		value: 'true'
		callback: [value contents: true]. 
		
	callbackBlock fixTemps.
	self hiddenInputWithCallback: [callbackBlock value: value contents].
! !

!WAHtmlRenderer methodsFor: 'anchors' stamp: 'avi 1/23/2004 01:35'!
anchorName: aString do: aBlock
	self attributes at: 'name' put: aString.
	self tag: 'a'.
	anchorNames addLast: aString.
	aBlock value.
	anchorNames removeLast.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
defaultAction: actionBlock
	self
		inputWithType: 'hidden'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
radioGroup
	^ self callbacks registerDispatchCallback.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/20/2003 01:27'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForList: aCollection on: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self
			selectFromList: aCollection
			selected: (anObject perform: aSymbol)
			callback: (self callbackForSelector: aSymbol of: anObject)]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'lr 1/5/2004 13:38'!
iframe: aBlock
	| oldDocument oldAttributes contentsDocument |
	oldDocument _ self document.
	oldAttributes _ self attributes.
	[ document _ WAHtmlResponse new.
	  attributeBuffer _ nil.
	  self attributeAt: #target put: '_top'.
	  self headTag: #base.
	  aBlock value.
	  contentsDocument _ document ] 
	ensure: [
		document _ oldDocument.
		attributeBuffer _ oldAttributes ].
	self attributeAt: #src put: (self 
		urlForDocument: contentsDocument contents contents
		mimeType: contentsDocument contentType).
	self tag: #iframe! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
anchorWithDocument: anObject mimeType: mimeType text: aString
	self anchorWithDocument: anObject mimeType: mimeType fileName: nil text: aString! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
submitButtonWithAction: aBlock text: aString
	self attributeAt: 'value' put: aString.
	self submitButtonWithAction: aBlock! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 1/14/2004 22:46'!
registry
	^ WASession currentSession application ! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:14'!
passwordInputWithCallback: callbackBlock
	self
		valueInputOfType: 'password'
		value: ''
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForCheckboxOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self checkboxOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'jf 1/12/2004 14:35'!
checkboxOn: aSymbol of: anObject
	self
		checkboxWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 5/6/2003 18:37'!
booleanMenuWithValue: aBoolean callback: callbackBlock labels: labelArray
	self
		selectFromList: (Array with: true with: false)
		selected: aBoolean
		callback: callbackBlock
		labels: [:b | b ifTrue: [labelArray first] ifFalse: [labelArray second]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
submitButtonOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		submitButtonWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/25/2003 23:03'!
selectInputOn: selectedSymbol of: anObject list: aCollection
	self
		selectFromList: aCollection
		selected: (anObject perform: selectedSymbol)
		callback: (self callbackForSelector: selectedSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
fileUploadWithCallback: aBlock
	self inputWithType: 'file' named: (self callbacks registerCallback: aBlock)
! !

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 18:47'!
fromContext: aRenderingContext
	^ self basicNew initializeWithContext: aRenderingContext! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:15'!
textInputWithCallback: callbackBlock
	self textInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 4/8/2003 14:26'!
anchorWithAction: actionBlock form: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:40'!
form: aBlock
	self
		formWithMethod: 'post'
		action: self actionUrl, self currentAnchorName 
		do: aBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:30'!
labelledRowForTextInputOn: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
		self textInputOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:31'!
anchorWithAction: actionBlock do: linkBlock
	self openAnchorWithAction: actionBlock.
	self render: linkBlock.
	self closeTag: 'a'.

! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 1/11/2003 13:28'!
anchorWithDocument: anObject text: aString
	self anchorWithDocument: anObject mimeType: nil text: aString! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:31'!
anchorWithAction: actionBlock text: aString
	self anchorWithAction: actionBlock do: aString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'JF 5/27/2003 15:18'!
imageWithForm: aForm
	self image: (self urlForDocument: aForm) width: aForm width height: aForm height! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
hiddenInputWithValue: anObject callback: callbackBlock
	self valueInputOfType: 'hidden'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 7/11/2003 00:09'!
parseImageMap: aString
	|s x y|
	('?*,*' match: aString) ifFalse: [^ nil].
	s _ aString readStream.
	s upTo: $?.
	x _ s upTo: $,.
	y _ s upToEnd.
	^ x asNumber @ y asNumber
	! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
textInputOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		textInputWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:47'!
callbacks
	^ context callbacks! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/20/2003 18:43'!
anchorWithDocument: anObject mimeType: mimeType fileName: fileName text: aString
	self openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName.
	self text: aString.
	self closeTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:51'!
hiddenInputWithCallback: callbackBlock
	self inputWithType: 'hidden' named: (self callbacks registerCallback: callbackBlock)
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 1/23/2004 01:33'!
initializeWithContext: aRenderingContext
	context _ aRenderingContext.
	anchorNames _ OrderedCollection new.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/20/2003 18:49'!
imageMapWithAction: aBlock form: aForm
	|point actionKey pointKey|
	point _ ValueHolder new.
	pointKey _ self callbacks registerCallback: [:ptString | point contents: (self parseImageMap: ptString)].
	actionKey _ self callbacks registerActionCallback: [aBlock value: point contents].
	self
		attributeAt: 'href'
		put: self actionUrl, '?', actionKey, '&', pointKey, '='.
	self tag: 'a' do: [
		self attributeAt: 'border' put: 0; attributeAt: 'ismap' put: true.
		self imageWithForm: aForm.
	]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
urlForAction: actionBlock
	^ self actionUrl, '?', (self callbacks registerActionCallback: actionBlock)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
anchorOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		anchorWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:31'!
labelledRowForTextInputOn: aSymbol of: anObject
	self labelledRowForTextInputOn: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:38'!
openAnchorWithAction: actionBlock
	self
		attributeAt: 'href'
		put: (self urlForAction: actionBlock), self currentAnchorName.
	self openTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
textAreaOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		textAreaWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 2/12/2003 17:21'!
booleanMenuOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		booleanMenuWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:24'!
linkWithScript: jsString
	self scriptWithUrl: (self urlForDocument: jsString mimeType: 'text/javascript' fileName: nil)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
callbackForSelector: aSymbol of: anObject
	^ MessageSend receiver: anObject selector: (aSymbol copyWith: $:) asSymbol! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/14/2004 23:23'!
textAreaWithValue: value callback: callbackBlock
	|callback name |
	callback _ value
					ifNil: [[:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]]
					ifNotNil: [callbackBlock].
	name _ self callbacks registerCallback: callback.
	self attributes
		at: 'name' put: name;
		at: 'id' ifAbsentPut: name.
	
	self tag: 'textarea' do: value.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock
	self attributeAt: 'checked' put: aBoolean.
	
	self inputWithType: 'radio' named: radioGroupKey value: (self callbacks registerCallback: callbackBlock)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 2/12/2003 19:40'!
linkWithStyle: cssString
	self styleLinkWithUrl: (self urlForDocument: cssString mimeType: 'text/css')! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
submitButtonWithAction: actionBlock
	self inputWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
valueInputOfType: typeString value: anObject callback: callbackBlock
	|updateKey callback value|
	value _ anObject.
	callback _ callbackBlock.
	anObject isNumber ifTrue:
		[anObject isFraction
			ifTrue:
				[value _ anObject asFloat asString.
				callback _ [:v | callbackBlock value:
									(v = value ifTrue: [anObject] ifFalse: [v asNumber])]]
			ifFalse:
				[callback _ [:v | callbackBlock value: v asNumber]]].
	anObject isNil ifTrue:
		[value _ ''.
		callback _ [:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]].
					
	updateKey _ self callbacks registerCallback: callback.
	self inputWithType: typeString named: updateKey value: value.
	^ updateKey
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
optionWithLabel: labelString selected: aBoolean callback: callbackBlock
	self 
		attributeAt: 'selected' put: aBoolean;
		attributeAt: 'value' put: (self callbacks registerCallback: callbackBlock).
	
	self tag: 'option' do: labelString.! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:46'!
document
	^ context document! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
textInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'text'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForTextAreaOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self textAreaOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 1/23/2004 01:38'!
actionUrl
	^ context actionUrl! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 2/12/2003 17:21'!
booleanMenuWithValue: aBoolean callback: callbackBlock
	self booleanMenuWithValue: aBoolean callback: callbackBlock labels: #(Yes No)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'jf 11/20/2003 16:11'!
radioButtonInGroup: radioGroupKey withValue: value on: aSelector of: anObject
	self
		radioButtonInGroup: radioGroupKey
		selected: (value = (anObject perform: aSelector))
		callback: [:v | anObject perform: aSelector asMutator with: value]! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 2/12/2003 19:41'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock
	self selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: [:i | i asString]! !

!WAHtmlRenderer methodsFor: 'anchors' stamp: 'avi 1/23/2004 01:35'!
currentAnchorName
	^ anchorNames isEmpty
		ifTrue: ['']
		ifFalse: ['#', anchorNames last]! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableData: aBlock
	self tag: 'td' do: aBlock! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 5/30/2003 00:29'!
spacerRow
	self tableRowWith: [self space]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:23'!
image: urlString width: width height: height
	self image: urlString width: width height: height altText: ''! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
metaTagNamed: nameString content: contentString
	self attributes
		at: 'name' put: nameString;
		at: 'content' put: contentString.
	self headTag: 'meta'.! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString do: anObject
	self openTag: aString.
	self render: anObject.
	self closeTag: aString.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 8/7/2003 17:22'!
space: aNumber
	aNumber timesRepeat: [self text: '&nbsp;']! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTableOfWidth: width do: aBlock
	self attributes width: width.
	self layoutTable: aBlock! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:25'!
inputWithType: type named: name	
	self inputWithType: type named: name value: nil.
! !

!WAHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:19'!
submitButtonWithText: aString
	self attributes value: aString.
	self inputWithType: 'submit'
! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:48'!
styleLinkWithUrl: urlString
	self attributes
		at: 'rel' put: 'stylesheet';
		at: 'type' put: 'text/css';
		at: 'href' put: urlString.
	self headTag: 'link'! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
heading: aString
	self heading: aString level: 1! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTable: aBlock
	self attributes
		border: 0;
		cellspacing: 0;
		cellpadding: 0.
	self table: aBlock! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'avi 11/20/2003 18:41'!
formWithMethod: methodString action: actionUrl do: aBlock
	self attributes method: methodString;
			action: actionUrl.
	self tag: 'form' do: aBlock! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 6/10/2003 11:36'!
encodeText: anObject
	| encoded |
	encoded _ String streamContents:
		[:s |
		anObject asString do: [:char | s nextPutAll: (HtmlCharacters at: char ifAbsent: [char asString] )]].
	self text: encoded! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
horizontalRule
	self tag: 'hr'! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:20'!
anchorWithUrl: urlString do: aBlock
	self attributes href: urlString.
	self tag: 'a' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:26'!
tableHeadings: aCollection
	self tableRow: [aCollection do: [:ea | self tableHeading: ea]]! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph
	self tag: 'p'! !

!WAHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
scriptWithUrl: urlString
	self attributes
		at: 'language' put: 'javascript';
		at: 'src' put: urlString.
	self headTag: 'script'.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/13/2003 00:07'!
emphasis: aBlock
	self tag: 'em' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
underline: aBlock
	self tag: 'u' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:51'!
openTag: aString
	self document openTag: aString attributes: self attributes.
	attributeBuffer _ nil.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
list: aCollection
	self list: aCollection do: [:x | self text: x]! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:04'!
table: aBlock
	self tag: 'table' do: aBlock! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock column: anotherBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock; tableData: anotherBlock]! !

!WAHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:44'!
closeTag: aString
	self document closeTag: aString ! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divNamed: aString with: anObject
	self cssId: aString; div: anObject! !

!WAHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'kph 4/4/2003 04:32'!
initialize
	"WAHtmlBuilder initialize"

	HtmlCharacters _ Dictionary new: 128.
	#('quot' $" 'lt' $< 'amp' $& 'gt' $> ) pairsDo:
		[:s :c | HtmlCharacters at: c  put: ('&',s,';') ].
	#('nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo:
		[:s :i | HtmlCharacters at: (i - 1 + 160) asCharacter put:  ('&',s,';')].  ! !

!WAHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanNamed: aString with: anObject
	self cssId: aString; span: anObject! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRow: aBlock
	self tag: 'tr' do: aBlock! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:22'!
image: urlString width: width height: height altText: altString
	self attributeAt: 'width' put: width.
	self attributeAt: 'height' put: height.
	
	self image: urlString altText: altString! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
preformatted: anObject
	self tag: 'pre' do: anObject! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
listItem: aBlock
	self tag: #li do: aBlock! !

!WAHtmlBuilder methodsFor: 'model' stamp: 'ac 9/22/2003 16:35'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
submitButton
	self inputWithType: 'submit'
! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
bold: aBlock
	self tag: 'b' do: aBlock.! !

!WAHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
space
	self text: '&nbsp;'! !

!WAHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: x with: y with: z
	self tableRow: [ self tableData: x; tableData: y; tableData: z]! !

Object subclass: #WAStoreItem
	instanceVariableNames: 'title subtitle description price '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store-Model'!

!WAStoreItem commentStamp: 'avi 1/1/2004 09:34' prior: 0!
Models a single item of inventory - stores a title, subtitle, fill description, and price.  The only real behavior is #matches:, which is used for search.!

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price
	^ price! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description: aString
	description _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:17'!
subtitle: aString
	subtitle_ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:17'!
printString
	^ self title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:17'!
subtitle
	^ subtitle! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title
	^ title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price: cents
	price _ cents! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description
	^ description! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title: aString
	title _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:30'!
matches: aString
	^ (title includesSubstring: aString caseSensitive: false)
		or: [description includesSubstring: aString caseSensitive: false]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'timeout process responseSem mutex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Utilities'!

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:54'!
timeoutSeconds: aNumber
	timeout _ aNumber! !

!WAProcessMonitor class methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:53'!
new
	^ super new initialize! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 14:50'!
timeout
	^ timeout! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'avi 1/20/2004 13:40'!
initialize
	timeout _ 5.
	mutex _ Semaphore forMutualExclusion.
	process _ [] newProcess.! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'avi 1/20/2004 13:39'!
critical: aBlock
	|value|
	mutex waitTimeoutSeconds: self timeout.
	responseSem _ Semaphore new.
	process install: 
		[[value _ aBlock value] ensure: [responseSem signal]]
			newProcess suspendedContext.
	process resume.
	responseSem wait.
	process terminate.
	mutex signal.
	^ value! !

Object subclass: #WAPluggableSelectBox
	instanceVariableNames: 'changeSelected model selected size list '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Tools'!

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:25'!
size: aNumber
	size _ aNumber! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:27'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector size: aNumber
	^ self new
		model: anObject;
		list: listSelector;
		selected: selectedSelector;
		changeSelected: changeSelectedSelector;
		size: aNumber! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:28'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector
	^ self 
		on: anObject
		list: listSelector
		selected: selectedSelector
		changeSelected: changeSelectedSelector
		size: 10! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:24'!
model: anObject
	model _ anObject! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderOn: html
	|array|
	array _ (model perform: list) asArray.
	html divClass: 'column-choice' with:	
		[html form:
			[html attributeAt: 'size' put: size.
			html attributeAt: 'onChange' put: 'submit()'.
			html
				selectFromList: array
				selected: (array at: (model perform: selected) ifAbsent: [])
				callback: [:item | model perform: changeSelected with: (array indexOf: item)]]].	! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
changeSelected: aSymbol
	changeSelected _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
list: aSymbol
	list _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
selected: aSymbol
	selected _ aSymbol! !

Object subclass: #WAApplicationFlow
	instanceVariableNames: 'session '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

!WAApplicationFlow methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:43'!
initializeWithSession: aSession
	session _ aSession! !

!WAApplicationFlow methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:25'!
start: aRequest
	self subclassResponsibility! !

!WAApplicationFlow methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:26'!
session
	^ session! !

WAApplicationFlow subclass: #WARenderLoop
	instanceVariableNames: 'root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Core'!

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 1/22/2004 12:00'!
renderNow
	WARenderNotification signal! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/2/2004 19:25'!
renderControllerForever: aController
	[self withRenderNowHandler: [self renderController: aController]] repeat! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/2/2004 01:20'!
alwaysRedirect	
	^ self application preferenceAt: #alwaysRedirect! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/2/2004 01:44'!
renderController: aController
	|request callbacks|

	callbacks _ WACallbackStore new.
	request _ self session respond:
				[:url |
				self responseWithUrl: url callbacks: callbacks controller: aController].
	callbacks processRequest: request.
	self alwaysRedirect ifTrue: [self session redirect].! !

!WARenderLoop methodsFor: 'request handling' stamp: 'avi 2/2/2004 01:20'!
rootFromRequest: aRequest
	|component|
	component _ self createRootFromRequest: aRequest.
	^ (self application preferenceAt: #showToolbar)
		ifTrue: [WAToolFrame on: component]
		ifFalse: [component]! !

!WARenderLoop methodsFor: 'error handling' stamp: 'avi 1/23/2004 00:02'!
handleWarning: aWarning
	self handleError: aWarning! !

!WARenderLoop methodsFor: 'request handling' stamp: 'avi 1/23/2004 19:59'!
start: aRequest
	root _ self rootFromRequest: aRequest.
	self call: root.! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/2/2004 02:15'!
withRenderNowHandler: aBlock
	^ [aBlock
		on: WARenderNotification do: [:n]]
		on: WAPageExpired do: [:n]! !

!WARenderLoop methodsFor: 'request handling' stamp: 'avi 2/2/2004 01:20'!
createRootFromRequest: aRequest
	^ (self application preferenceAt: #entryPoint) new! !

!WARenderLoop class methodsFor: 'as yet unclassified' stamp: 'ab 3/20/2003 12:10'!
entryPoints
	^ WAController allSubclasses asSortedCollection: [:a :b | a name <= b name]! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 1/23/2004 19:53'!
call: aController
	aController onAnswer: [:v | ^ v].
	self renderControllerForever: aController.! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 1/23/2004 19:50'!
responseWithUrl: urlString callbacks: aCallbackStore controller: aController
	| document |
	document _ WAHtmlResponse new.
	aController renderActiveControllerWithContext:
		(WARenderingContext new
			document: document;
			actionUrl: urlString;
			callbacks: aCallbackStore).
	^ document! !

!WAApplicationFlow class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:26'!
session: aSession
	^ self basicNew initializeWithSession: aSession! !

!WAApplicationFlow methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:27'!
application
	^ session application! !

Object subclass: #WAFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

WAFilter subclass: #WAOnce
	instanceVariableNames: 'seenKeys '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

!WAOnce methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 01:47'!
handleRequest: aRequest inSession: aSession
	(seenKeys includes: aRequest actionKey)
		ifTrue: [aSession pageExpired]
		ifFalse: [seenKeys add: aRequest actionKey]! !

!WAOnce methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 01:47'!
initialize
	seenKeys _ Set new! !

!WAOnce class methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 01:46'!
new
	^ super new initialize! !

!WAFilter methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 13:10'!
handleRequest: aRequest inSession: aSession
	! !

WAFilter subclass: #WATransaction
	instanceVariableNames: 'active '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 15:41'!
handleRequest: aRequest inSession: aSession
	^ active
		ifTrue: [aRequest]
		ifFalse: [aSession pageExpired].
	! !

!WATransaction class methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
new
	^ super new initialize! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
initialize
	active _ true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
close
	active _ false! !

WAFilter subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Filters'!

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 13:03'!
handleRequest: aRequest inSession: aSession
	^ (authenticator verifyPassword: aRequest password  forUser: aRequest user)
		ifTrue: [aRequest]
		ifFalse: [aSession returnResponse: (WABasicAuthResponse realm: aSession basePath)]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 13:03'!
authenticator: anAuthenticator
	authenticator _ anAuthenticator! !

Object subclass: #WACallbackStore
	instanceVariableNames: 'count action callbacks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Rendering-Core'!

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2002 23:23'!
sortRequest: aDictionary
	|sorted|
	sorted _ SortedCollection sortBlock: [:x :y | x key asNumber < y key asNumber].
	aDictionary ifNotNil:
		[aDictionary keysAndValuesDo:
			[:k :v|
			k asInteger ifNotNil:
				[sorted add: k -> (self valueForField: v)]]].
	^ sorted! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:41'!
storeCallback: aCallback
	|key|
	key _ (count _ count + 1) asString.
	callbacks at: key put: aCallback.
	^ key
! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:55'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackStore class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2002 23:10'!
new
	^ super new initialize! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:49'!
evaluateCallbackAt: callbackKey with: anObject
	(callbacks at: callbackKey) evaluateWithObject: anObject store: self! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:55'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 10/2/2002 00:19'!
valueForField: field 
	^ field
		ifNil: ['']
		ifNotNil:
			[(field isCollection and: [field isString not])
					ifTrue: [field isEmpty
								ifTrue: ['']
								ifFalse: [field first]]
					ifFalse: [field]]! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:54'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:40'!
initialize
	callbacks _ Dictionary new.
	count _ 0.	! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 19:51'!
action: anActionCallback
	action _ anActionCallback! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 00:56'!
processRequest: aRequest
	action _ nil.
	(self sortRequest: aRequest fields) do:
		[:assoc | self evaluateCallbackAt: assoc key with: assoc value].
	^ action ifNotNil: [action trigger]! !

Object subclass: #WAStoreCreditCard
	instanceVariableNames: 'name number expiry '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store-Model'!

!WAStoreCreditCard commentStamp: 'avi 1/1/2004 07:47' prior: 0!
Models credit card information - it has accessors for #name and #number (both strings), and #expiry date.  #validate throws an error if anything is missing, or if the expiry date is in the past.

This is intended to be an abstract class - the subclasses WAStoreMasterCard and WAStoreVisaCard provide further validation.!

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:03'!
expiry: aDate
	expiry _ aDate! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
number
	^ number! !

WAStoreCreditCard subclass: #WAStoreMasterCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store-Model'!

!WAStoreMasterCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds MasterCard-specific validation to WAStoreCreditCard.!

!WAStoreMasterCard methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 15:01'!
validate
	super validate.
	number first = $5 ifFalse: [self error: 'Mastercard numbers must start with "5"'].
! !

!WAStoreMasterCard class methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'MC'! !

WAStoreCreditCard subclass: #WAStoreVisaCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Examples-Store-Model'!

!WAStoreVisaCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds VISA-specific validation to WAStoreCreditCard.!

!WAStoreVisaCard class methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'VISA'! !

!WAStoreVisaCard methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 15:00'!
validate
	super validate.
	number first = $4 ifFalse: [self error: 'Visa card numbers must start with "4"'].
! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:01'!
name: aString
	name _ aString! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
number: aString
	number _ aString! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
expiry
	! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:03'!
validate
	name ifNil: [self error: 'You must provide the name of the credit card owner.'].
	number ifNil: [self error: 'You must provide a credit card number.'].
	expiry ifNil: [self error: 'You must provide an expiry date.'].
	expiry < Date today ifTrue: [self error: 'The expiry date must not be in the past'].
	! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
name
	^ name! !

Object subclass: #WAStateRegistry
	instanceVariableNames: 'lastSnapshot objects '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-State'!

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 15:32'!
snapshot
	lastSnapshot := SeasidePlatformSupport weakDictionaryOfSize: objects size.
	objects keysAndValuesDo:
		[:obj :copy|
		(self snapshot: copy isIdenticalTo: obj)
			ifTrue: [lastSnapshot at: obj put: copy]
			ifFalse: [lastSnapshot at: obj put: obj shallowCopy]].
	^ lastSnapshot
! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:28'!
restoreLastSnapshot
	lastSnapshot ifNotNil: [self restoreSnapshot: lastSnapshot]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:11'!
restoreObject: object fromSnapshot: copy
	1 to: object class instSize do: [:i | object instVarAt: i put: (copy instVarAt: i)].
	object class isVariable ifTrue: [1 to: object size do: [:i | object at: i put: (copy at: i)]].
	objects at: object put: copy.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:55'!
calculateFootprint
	^ (objects detectSum: [:ea | 2 + ea class instSize + (ea class isVariable ifTrue: [ea size + 1] ifFalse: [0])]) * 4! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:02'!
registerObject: anObject
	objects at: anObject put: anObject shallowCopy! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
size
	^ objects size! !

!WAStateRegistry class methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:38'!
new
	^ super new initialize! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:11'!
snapshot: copy isIdenticalTo: object
	1 to: object class instSize do: [:i | (copy instVarAt: i) == (object instVarAt: i) ifFalse: [^ false]].
	object class isVariable ifTrue:
		[1 to: object size do: [:i | (copy at: i) == (object at: i) ifFalse: [^ false]]].
	^ true! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
restoreSnapshot: aDictionary
	aDictionary keysAndValuesDo:
		[:k :v |
		self restoreObject: k fromSnapshot: v]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:02'!
initialize
	objects _ SeasidePlatformSupport weakDictionaryOfSize: 10.! !

!Date class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:29'!
newDay: dayNumber monthNumber: monthNumber year: yearNumber
	^ self newDay: dayNumber month: monthNumber year: yearNumber! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 3/28/2003 17:36'!
reactivateHandler 
  handlerContext ifNotNil: [handlerContext tempAt: 3 put: true].
! !

TestCase subclass: #AmbTest
	instanceVariableNames: 'amb '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Tests'!

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 13:33'!
testMaybe
	|x y z|
	x _ amb maybe.
	y _ amb maybe.
	z _ amb maybe not.

	amb deny: x = y.
	amb deny: x = z.
	
	self assert: {x. y. z} = {true. false. false}.	! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/13/2002 01:15'!
setUp
	amb _ Amb new! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumber
	^ self pickANumberGreaterThan: 0! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 03:06'!
testSicpLogicProblemFaster
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"
	
	|baker cooper fletcher miller smith|
	fletcher _ amb oneOf: (1 to: 5).
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.

	smith _ amb oneOf: (1 to: 5).
	amb deny: (smith - fletcher) abs = 1.

	cooper _ amb oneOf: (1 to: 5).
	amb deny: cooper = 1.
	amb deny: (fletcher - cooper) abs = 1.

	miller _ amb oneOf: (1 to: 5).
	amb assert: miller > cooper.

	baker _ amb oneOf: (1 to: 5).
	amb deny: baker = 5.
	
	amb assert: {baker. cooper. fletcher. miller. smith} asSet size = 5.
	self assert: {baker. cooper. fletcher. miller. smith} = #(3 2 4 5 1).! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumberAboveFive
	|x|
	x _ self pickANumber.
	amb assert: (x > 5).
	self assert: x = 6.
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:43'!
testAllValuesAboveFive
	|x results|
	results _ amb allValues:
				[x _ amb oneOf: (1 to: 10).
				amb assert: (x > 5).
				x].			
	self assert: results = #(6 7 8 9 10).
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:27'!
testSolveAnEquation
	|x y|
	x _ amb oneOf: (1 to: 10).
	y _ amb oneOf: (1 to: 10).
	amb assert: (y * x) = 42.
	self assert: x = 6.
	self assert: y = 7.
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumberGreaterThan: aNumber
	^ amb valueOf: [aNumber + 1] or: [self pickANumberGreaterThan: aNumber + 1]! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 13:16'!
testSicpLogicProblem
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"

"This implementation is too slow - uncomment to actually run it."
	
"	|baker cooper fletcher miller smith|
	baker _ amb oneOf: (1 to: 5).
	cooper _ amb oneOf: (1 to: 5).
	fletcher _ amb oneOf: (1 to: 5).
	miller _ amb oneOf: (1 to: 5).
	smith _ amb oneOf: (1 to: 5).
	
	amb assert: {baker. cooper. fletcher. miller. smith} asSet size = 5.
	
	amb deny: baker = 5.
	amb deny: cooper = 1.
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.
	amb assert: miller > cooper.
	amb deny: (smith - fletcher) abs = 1.
	amb deny: (fletcher - cooper) abs = 1.
	
	self assert: {baker. cooper. fletcher. miller. smith} = #(3 2 4 5 1)."! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumber
	self assert: self pickANumber = 1.! !

TestCase subclass: #WAStateRegistryTest
	instanceVariableNames: 'registry '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Tests'!

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
snapshot: x isIdenticalTo: y
	^ ((IdentitySet withAll: x values) includesAllOf: y values).! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:23'!
testConsecutiveSnapshots
	|a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	snap2 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap2).
	a contents: 2.
	snap3 _ registry snapshot.
	self deny: (self snapshot: snap3 isIdenticalTo: snap2).
	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:16'!
setUp
	registry _ WAStateRegistry new! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:17'!
testRevert
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:21'!
testGarbageCollection
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	Smalltalk garbageCollect.
	self assert: registry size = 1.
	a _ nil.
	Smalltalk garbageCollect.
	self assert: registry size = 0.! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:22'!
testRevertTwice
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	a contents: 3.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:24'!
testNoChangeAfterRestore
	| a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	snap2 _ registry snapshot.
	self deny: (self snapshot: snap1 isIdenticalTo: snap2).
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	snap3 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap3).! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
assertSnapshot: x isIdenticalTo: y
	! !

TestCase subclass: #ContinuationTest
	instanceVariableNames: 'tmp tmp2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Tests'!

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockEscape
	|x|
	tmp _ 0.
	x _ [tmp _ tmp + 1. tmp2 value].
	self callcc: [:cc | tmp2 _ cc. x value].
	tmp2 _ [].
	x value.
	self assert: tmp = 2.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockTemps
	|y|
	#(1 2 3) do:
		[:i ||x|
			x _ i.
			tmp ifNil: [tmp2 _ (self callcc: [:cc | tmp _ cc. [:q]])].
			tmp2 value: x.
			x _ 17].
	y _ (self callcc: [:cc | tmp value: cc. 42]).
	self assert: y = 1.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockVars
	|continuation|
	tmp _ 0.
	tmp _ (self callcc: [:cc | continuation _ cc. 0]) + tmp.
	tmp2 
		ifNotNil: [tmp2 value]
		ifNil:
			[#(1 2 3) do:
				[:i |
				self callcc: [:cc | tmp2 _ cc. continuation value: i]]].
	self assert: tmp = 6.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testMethodTemps
	|i continuation|
	i _ 0.
	i _ i + (self callcc: [:cc | continuation _ cc. 1]).
	self assert: i ~= 3.
	i = 2 ifFalse: [continuation value: 2].! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 2/14/2003 01:17'!
testComprehension
	"What should this print out?
	
	|yin yang|
	yin := [:x | Transcript cr. x] value: Continuation current.
	yang := [:x | Transcript nextPut: $*. x] value: Continuation current.
	yin value: yang."! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:27'!
testSimplestCallCC
	|x|
	x _ self callcc: [:cc | cc value: true].
	self assert: x.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testSimpleCallCC
	|x continuation|
	x _ self callcc: [:cc | continuation _ cc. false].
	x ifFalse: [continuation value: true].
	self assert: x.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
callcc: aBlock
	^ Continuation currentDo: aBlock! !

!Stream methodsFor: '*seaside2-squeak' stamp: 'avi 8/31/2003 15:48'!
closed
	^false! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'ab 11/11/2002 12:06'!
renderOn: html
! !

!Dictionary methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'ab 5/28/2003 23:31'!
asMIMEDocument
	^ self imageForm asMIMEDocument! !

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Component-Utilities'!

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Session-Core'!

PackageInfo subclass: #Seaside2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Info'!

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 15:42'!
includesSystemCategory: aString
	^ aString beginsWith: 'Seaside/'! !

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 15:41'!
packageName
	^ 'Seaside2'! !

PackageInfo subclass: #SeasideVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside/Base-Info'!

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 23:10'!
packageName
	^ 'SeasideVW'! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW3
	VW3PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW3.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 17:46'!
externalName
	^ 'Seaside'! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 23:16'!
includesSystemCategory: aString
	^ (aString beginsWith: 'Seaside/') and: [(self ignoredCategories includes: (aString copyAfter: $/)) not]! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW5.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:01'!
ignoredCategories
	^ #('Base-Info' 'Base-Connections' 'Base-Platform' 'Session-Tests' 'Examples-Tutorial' 'Examples-SM' 'Examples-Wiki' 'Component-Tools-Squeak')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:13'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seaside2')
		and: [(aString endsWith: 'squeak') not]! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'ab 7/11/2003 00:10'!
upToAndSkipThroughAll: aCollection
	^ self upToAll: aCollection! !

!Parser methodsFor: '*seaside2-squeak-override' stamp: 'ab 2/21/2003 02:00'!
interactive

	^ (requestor == nil or: [requestor isKindOf: SyntaxError] or: [requestor isKindOf: WAMethodEditor]) not! !

!Form methodsFor: '*seaside2-squeak' stamp: 'ab 5/28/2003 23:30'!
asMIMEDocument 
	^ self asWebImage ! !

!BlockContext methodsFor: '*seaside2' stamp: 'ab 2/11/2003 20:09'!
handleRequest: aRequest
	^ self value: aRequest! !

!BlockContext methodsFor: '*seaside2' stamp: 'ac 5/16/2003 16:30'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

!String methodsFor: '*seaside2' stamp: 'ab 1/11/2003 12:46'!
printHtmlOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'JF 6/11/2003 13:15'!
renderOn: html indentLevel: level
	html encodeText: self! !

!String methodsFor: '*seaside2' stamp: 'ab 7/3/2003 13:04'!
asMIMEDocument 
	^ SeasidePlatformSupport mimeDocumentClass contentType: 'text/plain' content: self! !

!String methodsFor: '*seaside2' stamp: 'ab 3/29/2003 00:15'!
prettyPrintHtmlOn: aStream indentLevel: aNumber
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'ac 9/22/2003 16:34'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !

!Collection methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|i|
	i _ 0.
	^ self asArray collect: [:each | i _ i + 1. i -> each]! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:40'!
evaluateWithArguments: anArray
	^ self valueWithArguments: anArray! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 10/10/2002 01:40'!
fixTemps! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 8/24/2003 16:38'!
valueWithPossibleArgs: anArray 

	self numArgs = 0 ifTrue: [^self value].
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray].
	self numArgs > anArray size ifTrue: [
		^self valueWithArguments: anArray,
				(Array new: (self numArgs - anArray size))
	].
	^self valueWithArguments: (anArray copyFrom: 1 to: self numArgs)

! !

!Integer methodsFor: '*seaside2' stamp: 'ab 6/3/2003 00:58'!
printStringAsCents
	^ '$', (self // 100) asString, '.', (self \\ 100) asTwoCharacterString! !

!Array methodsFor: '*seaside2' stamp: 'ab 10/26/2002 21:26'!
renderOn: html
	self do: [:ea | ea renderOn: html]! !
WACalendarTest initialize!
WACounter initialize!
WADateRangeSelector initialize!
WADispatcherEditor initialize!
WAExampleBrowser initialize!
WAHtmlBuilder initialize!
WAKom initialize!
WAMultiCounter initialize!
WAScreenshot initialize!
WAStore initialize!
